var $jscomp = $jscomp || {};
$jscomp.scope = {};
$jscomp.ASSUME_ES5 = false;
$jscomp.ASSUME_NO_NATIVE_MAP = false;
$jscomp.ASSUME_NO_NATIVE_SET = false;
$jscomp.defineProperty = $jscomp.ASSUME_ES5 || typeof Object.defineProperties == 'function' ? Object.defineProperty : function(target, property, descriptor) {
  descriptor = descriptor;
  if (target == Array.prototype || target == Object.prototype) {
    return;
  }
  target[property] = descriptor.value;
};
$jscomp.getGlobal = function(maybeGlobal) {
  return typeof window != 'undefined' && window === maybeGlobal ? maybeGlobal : typeof global != 'undefined' && global != null ? global : maybeGlobal;
};
$jscomp.global = $jscomp.getGlobal(this);
$jscomp.polyfill = function(target, polyfill, fromLang, toLang) {
  if (!polyfill) {
    return;
  }
  var obj = $jscomp.global;
  var split = target.split('.');
  for (var i = 0; i < split.length - 1; i++) {
    var key = split[i];
    if (!(key in obj)) {
      obj[key] = {};
    }
    obj = obj[key];
  }
  var property = split[split.length - 1];
  var orig = obj[property];
  var impl = polyfill(orig);
  if (impl == orig || impl == null) {
    return;
  }
  $jscomp.defineProperty(obj, property, {configurable:true, writable:true, value:impl});
};
$jscomp.polyfill('Array.prototype.copyWithin', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(target, start, opt_end) {
    var len = this.length;
    target = Number(target);
    start = Number(start);
    opt_end = Number(opt_end != null ? opt_end : len);
    if (target < start) {
      opt_end = Math.min(opt_end, len);
      while (start < opt_end) {
        if (start in this) {
          this[target++] = this[start++];
        } else {
          delete this[target++];
          start++;
        }
      }
    } else {
      opt_end = Math.min(opt_end, len + start - target);
      target += opt_end - start;
      while (opt_end > start) {
        if (--opt_end in this) {
          this[--target] = this[opt_end];
        } else {
          delete this[target];
        }
      }
    }
    return this;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.SYMBOL_PREFIX = 'jscomp_symbol_';
$jscomp.initSymbol = function() {
  $jscomp.initSymbol = function() {
  };
  if (!$jscomp.global['Symbol']) {
    $jscomp.global['Symbol'] = $jscomp.Symbol;
  }
};
$jscomp.Symbol = function() {
  var counter = 0;
  function Symbol(opt_description) {
    return $jscomp.SYMBOL_PREFIX + (opt_description || '') + counter++;
  }
  return Symbol;
}();
$jscomp.initSymbolIterator = function() {
  $jscomp.initSymbol();
  var symbolIterator = $jscomp.global['Symbol'].iterator;
  if (!symbolIterator) {
    symbolIterator = $jscomp.global['Symbol'].iterator = $jscomp.global['Symbol']('iterator');
  }
  if (typeof Array.prototype[symbolIterator] != 'function') {
    $jscomp.defineProperty(Array.prototype, symbolIterator, {configurable:true, writable:true, value:function() {
      return $jscomp.arrayIterator(this);
    }});
  }
  $jscomp.initSymbolIterator = function() {
  };
};
$jscomp.arrayIterator = function(array) {
  var index = 0;
  return $jscomp.iteratorPrototype(function() {
    if (index < array.length) {
      return {done:false, value:array[index++]};
    } else {
      return {done:true};
    }
  });
};
$jscomp.iteratorPrototype = function(next) {
  $jscomp.initSymbolIterator();
  var iterator = {next:next};
  iterator[$jscomp.global['Symbol'].iterator] = function() {
    return this;
  };
  return iterator;
};
$jscomp.iteratorFromArray = function(array, transform) {
  $jscomp.initSymbolIterator();
  if (array instanceof String) {
    array = array + '';
  }
  var i = 0;
  var iter = {next:function() {
    if (i < array.length) {
      var index = i++;
      return {value:transform(index, array[index]), done:false};
    }
    iter.next = function() {
      return {done:true, value:void 0};
    };
    return iter.next();
  }};
  $jscomp.initSymbol();
  $jscomp.initSymbolIterator();
  iter[Symbol.iterator] = function() {
    return iter;
  };
  return iter;
};
$jscomp.polyfill('Array.prototype.entries', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function() {
    return $jscomp.iteratorFromArray(this, function(i, v) {
      return [i, v];
    });
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Array.prototype.fill', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(value, opt_start, opt_end) {
    var length = this.length || 0;
    if (opt_start < 0) {
      opt_start = Math.max(0, length + opt_start);
    }
    if (opt_end == null || opt_end > length) {
      opt_end = length;
    }
    opt_end = Number(opt_end);
    if (opt_end < 0) {
      opt_end = Math.max(0, length + opt_end);
    }
    for (var i = Number(opt_start || 0); i < opt_end; i++) {
      this[i] = value;
    }
    return this;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.findInternal = function(array, callback, thisArg) {
  if (array instanceof String) {
    array = String(array);
  }
  var len = array.length;
  for (var i = 0; i < len; i++) {
    var value = array[i];
    if (callback.call(thisArg, value, i, array)) {
      return {i:i, v:value};
    }
  }
  return {i:-1, v:void 0};
};
$jscomp.polyfill('Array.prototype.find', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(callback, opt_thisArg) {
    return $jscomp.findInternal(this, callback, opt_thisArg).v;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Array.prototype.findIndex', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(callback, opt_thisArg) {
    return $jscomp.findInternal(this, callback, opt_thisArg).i;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Array.from', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(arrayLike, opt_mapFn, opt_thisArg) {
    $jscomp.initSymbolIterator();
    opt_mapFn = opt_mapFn != null ? opt_mapFn : function(x) {
      return x;
    };
    var result = [];
    $jscomp.initSymbol();
    $jscomp.initSymbolIterator();
    var iteratorFunction = arrayLike[Symbol.iterator];
    if (typeof iteratorFunction == 'function') {
      arrayLike = iteratorFunction.call(arrayLike);
      var next;
      var k = 0;
      while (!(next = arrayLike.next()).done) {
        result.push(opt_mapFn.call(opt_thisArg, next.value, k++));
      }
    } else {
      var len = arrayLike.length;
      for (var i = 0; i < len; i++) {
        result.push(opt_mapFn.call(opt_thisArg, arrayLike[i], i));
      }
    }
    return result;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Object.is', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(left, right) {
    if (left === right) {
      return left !== 0 || 1 / left === 1 / right;
    } else {
      return left !== left && right !== right;
    }
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Array.prototype.includes', function(orig) {
  if (orig) {
    return orig;
  }
  var includes = function(searchElement, opt_fromIndex) {
    var array = this;
    if (array instanceof String) {
      array = String(array);
    }
    var len = array.length;
    var i = opt_fromIndex || 0;
    if (i < 0) {
      i = Math.max(i + len, 0);
    }
    for (; i < len; i++) {
      var element = array[i];
      if (element === searchElement || Object.is(element, searchElement)) {
        return true;
      }
    }
    return false;
  };
  return includes;
}, 'es7', 'es3');
$jscomp.polyfill('Array.prototype.keys', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function() {
    return $jscomp.iteratorFromArray(this, function(i) {
      return i;
    });
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Array.of', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(var_args) {
    return Array.from(arguments);
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Array.prototype.values', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function() {
    return $jscomp.iteratorFromArray(this, function(k, v) {
      return v;
    });
  };
  return polyfill;
}, 'es8', 'es3');
$jscomp.makeIterator = function(iterable) {
  $jscomp.initSymbolIterator();
  $jscomp.initSymbol();
  $jscomp.initSymbolIterator();
  var iteratorFunction = iterable[Symbol.iterator];
  return iteratorFunction ? iteratorFunction.call(iterable) : $jscomp.arrayIterator(iterable);
};
$jscomp.FORCE_POLYFILL_PROMISE = false;
$jscomp.polyfill('Promise', function(NativePromise) {
  if (NativePromise && !$jscomp.FORCE_POLYFILL_PROMISE) {
    return NativePromise;
  }
  function AsyncExecutor() {
    this.batch_ = null;
  }
  AsyncExecutor.prototype.asyncExecute = function(f) {
    if (this.batch_ == null) {
      this.batch_ = [];
      this.asyncExecuteBatch_();
    }
    this.batch_.push(f);
    return this;
  };
  AsyncExecutor.prototype.asyncExecuteBatch_ = function() {
    var self = this;
    this.asyncExecuteFunction(function() {
      self.executeBatch_();
    });
  };
  var nativeSetTimeout = $jscomp.global['setTimeout'];
  AsyncExecutor.prototype.asyncExecuteFunction = function(f) {
    nativeSetTimeout(f, 0);
  };
  AsyncExecutor.prototype.executeBatch_ = function() {
    while (this.batch_ && this.batch_.length) {
      var executingBatch = this.batch_;
      this.batch_ = [];
      for (var i = 0; i < executingBatch.length; ++i) {
        var f = executingBatch[i];
        executingBatch[i] = null;
        try {
          f();
        } catch (error) {
          this.asyncThrow_(error);
        }
      }
    }
    this.batch_ = null;
  };
  AsyncExecutor.prototype.asyncThrow_ = function(exception) {
    this.asyncExecuteFunction(function() {
      throw exception;
    });
  };
  var PromiseState = {PENDING:0, FULFILLED:1, REJECTED:2};
  var PolyfillPromise = function(executor) {
    this.state_ = PromiseState.PENDING;
    this.result_ = undefined;
    this.onSettledCallbacks_ = [];
    var resolveAndReject = this.createResolveAndReject_();
    try {
      executor(resolveAndReject.resolve, resolveAndReject.reject);
    } catch (e) {
      resolveAndReject.reject(e);
    }
  };
  PolyfillPromise.prototype.createResolveAndReject_ = function() {
    var thisPromise = this;
    var alreadyCalled = false;
    function firstCallWins(method) {
      return function(x) {
        if (!alreadyCalled) {
          alreadyCalled = true;
          method.call(thisPromise, x);
        }
      };
    }
    return {resolve:firstCallWins(this.resolveTo_), reject:firstCallWins(this.reject_)};
  };
  PolyfillPromise.prototype.resolveTo_ = function(value) {
    if (value === this) {
      this.reject_(new TypeError('A Promise cannot resolve to itself'));
    } else {
      if (value instanceof PolyfillPromise) {
        this.settleSameAsPromise_(value);
      } else {
        if (isObject(value)) {
          this.resolveToNonPromiseObj_(value);
        } else {
          this.fulfill_(value);
        }
      }
    }
  };
  PolyfillPromise.prototype.resolveToNonPromiseObj_ = function(obj) {
    var thenMethod = undefined;
    try {
      thenMethod = obj.then;
    } catch (error) {
      this.reject_(error);
      return;
    }
    if (typeof thenMethod == 'function') {
      this.settleSameAsThenable_(thenMethod, obj);
    } else {
      this.fulfill_(obj);
    }
  };
  function isObject(value) {
    switch(typeof value) {
      case 'object':
        return value != null;
      case 'function':
        return true;
      default:
        return false;
    }
  }
  PolyfillPromise.prototype.reject_ = function(reason) {
    this.settle_(PromiseState.REJECTED, reason);
  };
  PolyfillPromise.prototype.fulfill_ = function(value) {
    this.settle_(PromiseState.FULFILLED, value);
  };
  PolyfillPromise.prototype.settle_ = function(settledState, valueOrReason) {
    if (this.state_ != PromiseState.PENDING) {
      throw new Error('Cannot settle(' + settledState + ', ' + valueOrReason + '): Promise already settled in state' + this.state_);
    }
    this.state_ = settledState;
    this.result_ = valueOrReason;
    this.executeOnSettledCallbacks_();
  };
  PolyfillPromise.prototype.executeOnSettledCallbacks_ = function() {
    if (this.onSettledCallbacks_ != null) {
      for (var i = 0; i < this.onSettledCallbacks_.length; ++i) {
        asyncExecutor.asyncExecute(this.onSettledCallbacks_[i]);
      }
      this.onSettledCallbacks_ = null;
    }
  };
  var asyncExecutor = new AsyncExecutor;
  PolyfillPromise.prototype.settleSameAsPromise_ = function(promise) {
    var methods = this.createResolveAndReject_();
    promise.callWhenSettled_(methods.resolve, methods.reject);
  };
  PolyfillPromise.prototype.settleSameAsThenable_ = function(thenMethod, thenable) {
    var methods = this.createResolveAndReject_();
    try {
      thenMethod.call(thenable, methods.resolve, methods.reject);
    } catch (error) {
      methods.reject(error);
    }
  };
  PolyfillPromise.prototype.then = function(onFulfilled, onRejected) {
    var resolveChild;
    var rejectChild;
    var childPromise = new PolyfillPromise(function(resolve, reject) {
      resolveChild = resolve;
      rejectChild = reject;
    });
    function createCallback(paramF, defaultF) {
      if (typeof paramF == 'function') {
        return function(x) {
          try {
            resolveChild(paramF(x));
          } catch (error) {
            rejectChild(error);
          }
        };
      } else {
        return defaultF;
      }
    }
    this.callWhenSettled_(createCallback(onFulfilled, resolveChild), createCallback(onRejected, rejectChild));
    return childPromise;
  };
  PolyfillPromise.prototype['catch'] = function(onRejected) {
    return this.then(undefined, onRejected);
  };
  PolyfillPromise.prototype.callWhenSettled_ = function(onFulfilled, onRejected) {
    var thisPromise = this;
    function callback() {
      switch(thisPromise.state_) {
        case PromiseState.FULFILLED:
          onFulfilled(thisPromise.result_);
          break;
        case PromiseState.REJECTED:
          onRejected(thisPromise.result_);
          break;
        default:
          throw new Error('Unexpected state: ' + thisPromise.state_);
      }
    }
    if (this.onSettledCallbacks_ == null) {
      asyncExecutor.asyncExecute(callback);
    } else {
      this.onSettledCallbacks_.push(callback);
    }
  };
  function resolvingPromise(opt_value) {
    if (opt_value instanceof PolyfillPromise) {
      return opt_value;
    } else {
      return new PolyfillPromise(function(resolve, reject) {
        resolve(opt_value);
      });
    }
  }
  PolyfillPromise['resolve'] = resolvingPromise;
  PolyfillPromise['reject'] = function(opt_reason) {
    return new PolyfillPromise(function(resolve, reject) {
      reject(opt_reason);
    });
  };
  PolyfillPromise['race'] = function(thenablesOrValues) {
    return new PolyfillPromise(function(resolve, reject) {
      var iterator = $jscomp.makeIterator(thenablesOrValues);
      for (var iterRec = iterator.next(); !iterRec.done; iterRec = iterator.next()) {
        resolvingPromise(iterRec.value).callWhenSettled_(resolve, reject);
      }
    });
  };
  PolyfillPromise['all'] = function(thenablesOrValues) {
    var iterator = $jscomp.makeIterator(thenablesOrValues);
    var iterRec = iterator.next();
    if (iterRec.done) {
      return resolvingPromise([]);
    } else {
      return new PolyfillPromise(function(resolveAll, rejectAll) {
        var resultsArray = [];
        var unresolvedCount = 0;
        function onFulfilled(i) {
          return function(ithResult) {
            resultsArray[i] = ithResult;
            unresolvedCount--;
            if (unresolvedCount == 0) {
              resolveAll(resultsArray);
            }
          };
        }
        do {
          resultsArray.push(undefined);
          unresolvedCount++;
          resolvingPromise(iterRec.value).callWhenSettled_(onFulfilled(resultsArray.length - 1), rejectAll);
          iterRec = iterator.next();
        } while (!iterRec.done);
      });
    }
  };
  return PolyfillPromise;
}, 'es6', 'es3');
$jscomp.polyfill('Promise.prototype.finally', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(onFinally) {
    return this.then(function(value) {
      var promise = Promise.resolve(onFinally());
      return promise.then(function() {
        return value;
      });
    }, function(reason) {
      var promise = Promise.resolve(onFinally());
      return promise.then(function() {
        throw reason;
      });
    });
  };
  return polyfill;
}, 'es9', 'es3');
$jscomp.underscoreProtoCanBeSet = function() {
  var x = {a:true};
  var y = {};
  try {
    y.__proto__ = x;
    return y.a;
  } catch (e) {
  }
  return false;
};
$jscomp.setPrototypeOf = typeof Object.setPrototypeOf == 'function' ? Object.setPrototypeOf : $jscomp.underscoreProtoCanBeSet() ? function(target, proto) {
  target.__proto__ = proto;
  if (target.__proto__ !== proto) {
    throw new TypeError(target + ' is not extensible');
  }
  return target;
} : null;
$jscomp.generator = {};
$jscomp.generator.ensureIteratorResultIsObject_ = function(result) {
  if (result instanceof Object) {
    return;
  }
  throw new TypeError('Iterator result ' + result + ' is not an object');
};
$jscomp.generator.Context = function() {
  this.isRunning_ = false;
  this.yieldAllIterator_ = null;
  this.yieldResult = undefined;
  this.nextAddress = 1;
  this.catchAddress_ = 0;
  this.finallyAddress_ = 0;
  this.abruptCompletion_ = null;
  this.finallyContexts_ = null;
};
$jscomp.generator.Context.prototype.start_ = function() {
  if (this.isRunning_) {
    throw new TypeError('Generator is already running');
  }
  this.isRunning_ = true;
};
$jscomp.generator.Context.prototype.stop_ = function() {
  this.isRunning_ = false;
};
$jscomp.generator.Context.prototype.jumpToErrorHandler_ = function() {
  this.nextAddress = this.catchAddress_ || this.finallyAddress_;
};
$jscomp.generator.Context.prototype.next_ = function(value) {
  this.yieldResult = value;
};
$jscomp.generator.Context.prototype.throw_ = function(e) {
  this.abruptCompletion_ = {exception:e, isException:true};
  this.jumpToErrorHandler_();
};
$jscomp.generator.Context.prototype['return'] = function(value) {
  this.abruptCompletion_ = {'return':value};
  this.nextAddress = this.finallyAddress_;
};
$jscomp.generator.Context.prototype.jumpThroughFinallyBlocks = function(nextAddress) {
  this.abruptCompletion_ = {jumpTo:nextAddress};
  this.nextAddress = this.finallyAddress_;
};
$jscomp.generator.Context.prototype.yield = function(value, resumeAddress) {
  this.nextAddress = resumeAddress;
  return {value:value};
};
$jscomp.generator.Context.prototype.yieldAll = function(iterable, resumeAddress) {
  var iterator = $jscomp.makeIterator(iterable);
  var result = iterator.next();
  $jscomp.generator.ensureIteratorResultIsObject_(result);
  if (result.done) {
    this.yieldResult = result.value;
    this.nextAddress = resumeAddress;
    return;
  }
  this.yieldAllIterator_ = iterator;
  return this.yield(result.value, resumeAddress);
};
$jscomp.generator.Context.prototype.jumpTo = function(nextAddress) {
  this.nextAddress = nextAddress;
};
$jscomp.generator.Context.prototype.jumpToEnd = function() {
  this.nextAddress = 0;
};
$jscomp.generator.Context.prototype.setCatchFinallyBlocks = function(catchAddress, finallyAddress) {
  this.catchAddress_ = catchAddress;
  if (finallyAddress != undefined) {
    this.finallyAddress_ = finallyAddress;
  }
};
$jscomp.generator.Context.prototype.setFinallyBlock = function(finallyAddress) {
  this.catchAddress_ = 0;
  this.finallyAddress_ = finallyAddress || 0;
};
$jscomp.generator.Context.prototype.leaveTryBlock = function(nextAddress, catchAddress) {
  this.nextAddress = nextAddress;
  this.catchAddress_ = catchAddress || 0;
};
$jscomp.generator.Context.prototype.enterCatchBlock = function(nextCatchBlockAddress) {
  this.catchAddress_ = nextCatchBlockAddress || 0;
  var exception = this.abruptCompletion_.exception;
  this.abruptCompletion_ = null;
  return exception;
};
$jscomp.generator.Context.prototype.enterFinallyBlock = function(nextCatchAddress, nextFinallyAddress, finallyDepth) {
  if (!finallyDepth) {
    this.finallyContexts_ = [this.abruptCompletion_];
  } else {
    this.finallyContexts_[finallyDepth] = this.abruptCompletion_;
  }
  this.catchAddress_ = nextCatchAddress || 0;
  this.finallyAddress_ = nextFinallyAddress || 0;
};
$jscomp.generator.Context.prototype.leaveFinallyBlock = function(nextAddress, finallyDepth) {
  var preservedContext = this.finallyContexts_.splice(finallyDepth || 0)[0];
  var abruptCompletion = this.abruptCompletion_ = this.abruptCompletion_ || preservedContext;
  if (abruptCompletion) {
    if (abruptCompletion.isException) {
      return this.jumpToErrorHandler_();
    }
    if (abruptCompletion.jumpTo != undefined && this.finallyAddress_ < abruptCompletion.jumpTo) {
      this.nextAddress = abruptCompletion.jumpTo;
      this.abruptCompletion_ = null;
    } else {
      this.nextAddress = this.finallyAddress_;
    }
  } else {
    this.nextAddress = nextAddress;
  }
};
$jscomp.generator.Context.prototype.forIn = function(object) {
  return new $jscomp.generator.Context.PropertyIterator(object);
};
$jscomp.generator.Context.PropertyIterator = function(object) {
  this.object_ = object;
  this.properties_ = [];
  for (var property in object) {
    this.properties_.push(property);
  }
  this.properties_.reverse();
};
$jscomp.generator.Context.PropertyIterator.prototype.getNext = function() {
  while (this.properties_.length > 0) {
    var property = this.properties_.pop();
    if (property in this.object_) {
      return property;
    }
  }
  return null;
};
$jscomp.generator.Engine_ = function(program) {
  this.context_ = new $jscomp.generator.Context;
  this.program_ = program;
};
$jscomp.generator.Engine_.prototype.next_ = function(value) {
  this.context_.start_();
  if (this.context_.yieldAllIterator_) {
    return this.yieldAllStep_(this.context_.yieldAllIterator_.next, value, this.context_.next_);
  }
  this.context_.next_(value);
  return this.nextStep_();
};
$jscomp.generator.Engine_.prototype.return_ = function(value) {
  this.context_.start_();
  var yieldAllIterator = this.context_.yieldAllIterator_;
  if (yieldAllIterator) {
    var returnFunction = 'return' in yieldAllIterator ? yieldAllIterator['return'] : function(v) {
      return {value:v, done:true};
    };
    return this.yieldAllStep_(returnFunction, value, this.context_['return']);
  }
  this.context_['return'](value);
  return this.nextStep_();
};
$jscomp.generator.Engine_.prototype.throw_ = function(exception) {
  this.context_.start_();
  if (this.context_.yieldAllIterator_) {
    return this.yieldAllStep_(this.context_.yieldAllIterator_['throw'], exception, this.context_.next_);
  }
  this.context_.throw_(exception);
  return this.nextStep_();
};
$jscomp.generator.Engine_.prototype.yieldAllStep_ = function(action, value, nextAction) {
  try {
    var result = action.call(this.context_.yieldAllIterator_, value);
    $jscomp.generator.ensureIteratorResultIsObject_(result);
    if (!result.done) {
      this.context_.stop_();
      return result;
    }
    var resultValue = result.value;
  } catch (e) {
    this.context_.yieldAllIterator_ = null;
    this.context_.throw_(e);
    return this.nextStep_();
  }
  this.context_.yieldAllIterator_ = null;
  nextAction.call(this.context_, resultValue);
  return this.nextStep_();
};
$jscomp.generator.Engine_.prototype.nextStep_ = function() {
  while (this.context_.nextAddress) {
    try {
      var yieldValue = this.program_(this.context_);
      if (yieldValue) {
        this.context_.stop_();
        return {value:yieldValue.value, done:false};
      }
    } catch (e) {
      this.context_.yieldResult = undefined;
      this.context_.throw_(e);
    }
  }
  this.context_.stop_();
  if (this.context_.abruptCompletion_) {
    var abruptCompletion = this.context_.abruptCompletion_;
    this.context_.abruptCompletion_ = null;
    if (abruptCompletion.isException) {
      throw abruptCompletion.exception;
    }
    return {value:abruptCompletion['return'], done:true};
  }
  return {value:undefined, done:true};
};
$jscomp.generator.Generator_ = function(engine) {
  this.next = function(opt_value) {
    return engine.next_(opt_value);
  };
  this['throw'] = function(exception) {
    return engine.throw_(exception);
  };
  this['return'] = function(value) {
    return engine.return_(value);
  };
  $jscomp.initSymbolIterator();
  $jscomp.initSymbol();
  $jscomp.initSymbolIterator();
  this[Symbol.iterator] = function() {
    return this;
  };
};
$jscomp.generator.createGenerator = function(generator, program) {
  var result = new $jscomp.generator.Generator_(new $jscomp.generator.Engine_(program));
  if ($jscomp.setPrototypeOf) {
    $jscomp.setPrototypeOf(result, generator.prototype);
  }
  return result;
};
$jscomp.asyncExecutePromiseGenerator = function(generator) {
  function passValueToGenerator(value) {
    return generator.next(value);
  }
  function passErrorToGenerator(error) {
    return generator['throw'](error);
  }
  return new Promise(function(resolve, reject) {
    function handleGeneratorRecord(genRec) {
      if (genRec.done) {
        resolve(genRec.value);
      } else {
        Promise.resolve(genRec.value).then(passValueToGenerator, passErrorToGenerator).then(handleGeneratorRecord, reject);
      }
    }
    handleGeneratorRecord(generator.next());
  });
};
$jscomp.asyncExecutePromiseGeneratorFunction = function(generatorFunction) {
  return $jscomp.asyncExecutePromiseGenerator(generatorFunction());
};
$jscomp.asyncExecutePromiseGeneratorProgram = function(program) {
  return $jscomp.asyncExecutePromiseGenerator(new $jscomp.generator.Generator_(new $jscomp.generator.Engine_(program)));
};
$jscomp.checkEs6ConformanceViaProxy = function() {
  try {
    var proxied = {};
    var proxy = Object.create(new $jscomp.global['Proxy'](proxied, {'get':function(target, key, receiver) {
      return target == proxied && key == 'q' && receiver == proxy;
    }}));
    return proxy['q'] === true;
  } catch (err) {
    return false;
  }
};
$jscomp.USE_PROXY_FOR_ES6_CONFORMANCE_CHECKS = false;
$jscomp.ES6_CONFORMANCE = $jscomp.USE_PROXY_FOR_ES6_CONFORMANCE_CHECKS && $jscomp.checkEs6ConformanceViaProxy();
$jscomp.owns = function(obj, prop) {
  return Object.prototype.hasOwnProperty.call(obj, prop);
};
$jscomp.polyfill('WeakMap', function(NativeWeakMap) {
  function isConformant() {
    if (!NativeWeakMap || !Object.seal) {
      return false;
    }
    try {
      var x = Object.seal({});
      var y = Object.seal({});
      var map = new NativeWeakMap([[x, 2], [y, 3]]);
      if (map.get(x) != 2 || map.get(y) != 3) {
        return false;
      }
      map['delete'](x);
      map.set(y, 4);
      return !map.has(x) && map.get(y) == 4;
    } catch (err) {
      return false;
    }
  }
  if ($jscomp.USE_PROXY_FOR_ES6_CONFORMANCE_CHECKS) {
    if (NativeWeakMap && $jscomp.ES6_CONFORMANCE) {
      return NativeWeakMap;
    }
  } else {
    if (isConformant()) {
      return NativeWeakMap;
    }
  }
  var prop = '$jscomp_hidden_' + Math.random();
  function insert(target) {
    if (!$jscomp.owns(target, prop)) {
      var obj = {};
      $jscomp.defineProperty(target, prop, {value:obj});
    }
  }
  function patch(name) {
    var prev = Object[name];
    if (prev) {
      Object[name] = function(target) {
        insert(target);
        return prev(target);
      };
    }
  }
  patch('freeze');
  patch('preventExtensions');
  patch('seal');
  var index = 0;
  var PolyfillWeakMap = function(opt_iterable) {
    this.id_ = (index += Math.random() + 1).toString();
    if (opt_iterable) {
      $jscomp.initSymbol();
      $jscomp.initSymbolIterator();
      var iter = $jscomp.makeIterator(opt_iterable);
      var entry;
      while (!(entry = iter.next()).done) {
        var item = entry.value;
        this.set(item[0], item[1]);
      }
    }
  };
  PolyfillWeakMap.prototype.set = function(key, value) {
    insert(key);
    if (!$jscomp.owns(key, prop)) {
      throw new Error('WeakMap key fail: ' + key);
    }
    key[prop][this.id_] = value;
    return this;
  };
  PolyfillWeakMap.prototype.get = function(key) {
    return $jscomp.owns(key, prop) ? key[prop][this.id_] : undefined;
  };
  PolyfillWeakMap.prototype.has = function(key) {
    return $jscomp.owns(key, prop) && $jscomp.owns(key[prop], this.id_);
  };
  PolyfillWeakMap.prototype['delete'] = function(key) {
    if (!$jscomp.owns(key, prop) || !$jscomp.owns(key[prop], this.id_)) {
      return false;
    }
    return delete key[prop][this.id_];
  };
  return PolyfillWeakMap;
}, 'es6', 'es3');
$jscomp.MapEntry = function() {
  this.previous;
  this.next;
  this.head;
  this.key;
  this.value;
};
$jscomp.polyfill('Map', function(NativeMap) {
  function isConformant() {
    if ($jscomp.ASSUME_NO_NATIVE_MAP || !NativeMap || typeof NativeMap != 'function' || !NativeMap.prototype.entries || typeof Object.seal != 'function') {
      return false;
    }
    try {
      NativeMap = NativeMap;
      var key = Object.seal({x:4});
      var map = new NativeMap($jscomp.makeIterator([[key, 's']]));
      if (map.get(key) != 's' || map.size != 1 || map.get({x:4}) || map.set({x:4}, 't') != map || map.size != 2) {
        return false;
      }
      var iter = map.entries();
      var item = iter.next();
      if (item.done || item.value[0] != key || item.value[1] != 's') {
        return false;
      }
      item = iter.next();
      if (item.done || item.value[0].x != 4 || item.value[1] != 't' || !iter.next().done) {
        return false;
      }
      return true;
    } catch (err) {
      return false;
    }
  }
  if ($jscomp.USE_PROXY_FOR_ES6_CONFORMANCE_CHECKS) {
    if (NativeMap && $jscomp.ES6_CONFORMANCE) {
      return NativeMap;
    }
  } else {
    if (isConformant()) {
      return NativeMap;
    }
  }
  $jscomp.initSymbol();
  $jscomp.initSymbolIterator();
  var idMap = new WeakMap;
  var PolyfillMap = function(opt_iterable) {
    this.data_ = {};
    this.head_ = createHead();
    this.size = 0;
    if (opt_iterable) {
      var iter = $jscomp.makeIterator(opt_iterable);
      var entry;
      while (!(entry = iter.next()).done) {
        var item = entry.value;
        this.set(item[0], item[1]);
      }
    }
  };
  PolyfillMap.prototype.set = function(key, value) {
    key = key === 0 ? 0 : key;
    var r = maybeGetEntry(this, key);
    if (!r.list) {
      r.list = this.data_[r.id] = [];
    }
    if (!r.entry) {
      r.entry = {next:this.head_, previous:this.head_.previous, head:this.head_, key:key, value:value};
      r.list.push(r.entry);
      this.head_.previous.next = r.entry;
      this.head_.previous = r.entry;
      this.size++;
    } else {
      r.entry.value = value;
    }
    return this;
  };
  PolyfillMap.prototype['delete'] = function(key) {
    var r = maybeGetEntry(this, key);
    if (r.entry && r.list) {
      r.list.splice(r.index, 1);
      if (!r.list.length) {
        delete this.data_[r.id];
      }
      r.entry.previous.next = r.entry.next;
      r.entry.next.previous = r.entry.previous;
      r.entry.head = null;
      this.size--;
      return true;
    }
    return false;
  };
  PolyfillMap.prototype.clear = function() {
    this.data_ = {};
    this.head_ = this.head_.previous = createHead();
    this.size = 0;
  };
  PolyfillMap.prototype.has = function(key) {
    return !!maybeGetEntry(this, key).entry;
  };
  PolyfillMap.prototype.get = function(key) {
    var entry = maybeGetEntry(this, key).entry;
    return entry && entry.value;
  };
  PolyfillMap.prototype.entries = function() {
    return makeIterator(this, function(entry) {
      return [entry.key, entry.value];
    });
  };
  PolyfillMap.prototype.keys = function() {
    return makeIterator(this, function(entry) {
      return entry.key;
    });
  };
  PolyfillMap.prototype.values = function() {
    return makeIterator(this, function(entry) {
      return entry.value;
    });
  };
  PolyfillMap.prototype.forEach = function(callback, opt_thisArg) {
    var iter = this.entries();
    var item;
    while (!(item = iter.next()).done) {
      var entry = item.value;
      callback.call(opt_thisArg, entry[1], entry[0], this);
    }
  };
  $jscomp.initSymbol();
  $jscomp.initSymbolIterator();
  PolyfillMap.prototype[Symbol.iterator] = PolyfillMap.prototype.entries;
  var maybeGetEntry = function(map, key) {
    var id = getId(key);
    var list = map.data_[id];
    if (list && $jscomp.owns(map.data_, id)) {
      for (var index = 0; index < list.length; index++) {
        var entry = list[index];
        if (key !== key && entry.key !== entry.key || key === entry.key) {
          return {id:id, list:list, index:index, entry:entry};
        }
      }
    }
    return {id:id, list:list, index:-1, entry:undefined};
  };
  var makeIterator = function(map, func) {
    var entry = map.head_;
    return $jscomp.iteratorPrototype(function() {
      if (entry) {
        while (entry.head != map.head_) {
          entry = entry.previous;
        }
        while (entry.next != entry.head) {
          entry = entry.next;
          return {done:false, value:func(entry)};
        }
        entry = null;
      }
      return {done:true, value:void 0};
    });
  };
  var createHead = function() {
    var head = {};
    head.previous = head.next = head.head = head;
    return head;
  };
  var mapIndex = 0;
  var getId = function(obj) {
    var type = obj && typeof obj;
    if (type == 'object' || type == 'function') {
      obj = obj;
      if (!idMap.has(obj)) {
        var id = '' + ++mapIndex;
        idMap.set(obj, id);
        return id;
      }
      return idMap.get(obj);
    }
    return 'p_' + obj;
  };
  return PolyfillMap;
}, 'es6', 'es3');
$jscomp.polyfill('Math.acosh', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(x) {
    x = Number(x);
    return Math.log(x + Math.sqrt(x * x - 1));
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Math.asinh', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(x) {
    x = Number(x);
    if (x === 0) {
      return x;
    }
    var y = Math.log(Math.abs(x) + Math.sqrt(x * x + 1));
    return x < 0 ? -y : y;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Math.log1p', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(x) {
    x = Number(x);
    if (x < 0.25 && x > -0.25) {
      var y = x;
      var d = 1;
      var z = x;
      var zPrev = 0;
      var s = 1;
      while (zPrev != z) {
        y *= x;
        s *= -1;
        z = (zPrev = z) + s * y / ++d;
      }
      return z;
    }
    return Math.log(1 + x);
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Math.atanh', function(orig) {
  if (orig) {
    return orig;
  }
  var log1p = Math.log1p;
  var polyfill = function(x) {
    x = Number(x);
    return (log1p(x) - log1p(-x)) / 2;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Math.cbrt', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(x) {
    if (x === 0) {
      return x;
    }
    x = Number(x);
    var y = Math.pow(Math.abs(x), 1 / 3);
    return x < 0 ? -y : y;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Math.clz32', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(x) {
    x = Number(x) >>> 0;
    if (x === 0) {
      return 32;
    }
    var result = 0;
    if ((x & 4294901760) === 0) {
      x <<= 16;
      result += 16;
    }
    if ((x & 4278190080) === 0) {
      x <<= 8;
      result += 8;
    }
    if ((x & 4026531840) === 0) {
      x <<= 4;
      result += 4;
    }
    if ((x & 3221225472) === 0) {
      x <<= 2;
      result += 2;
    }
    if ((x & 2147483648) === 0) {
      result++;
    }
    return result;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Math.cosh', function(orig) {
  if (orig) {
    return orig;
  }
  var exp = Math.exp;
  var polyfill = function(x) {
    x = Number(x);
    return (exp(x) + exp(-x)) / 2;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Math.expm1', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(x) {
    x = Number(x);
    if (x < .25 && x > -.25) {
      var y = x;
      var d = 1;
      var z = x;
      var zPrev = 0;
      while (zPrev != z) {
        y *= x / ++d;
        z = (zPrev = z) + y;
      }
      return z;
    }
    return Math.exp(x) - 1;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Math.hypot', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(x, y, var_args) {
    x = Number(x);
    y = Number(y);
    var i, z, sum;
    var max = Math.max(Math.abs(x), Math.abs(y));
    for (i = 2; i < arguments.length; i++) {
      max = Math.max(max, Math.abs(arguments[i]));
    }
    if (max > 1e100 || max < 1e-100) {
      if (!max) {
        return max;
      }
      x = x / max;
      y = y / max;
      sum = x * x + y * y;
      for (i = 2; i < arguments.length; i++) {
        z = Number(arguments[i]) / max;
        sum += z * z;
      }
      return Math.sqrt(sum) * max;
    } else {
      sum = x * x + y * y;
      for (i = 2; i < arguments.length; i++) {
        z = Number(arguments[i]);
        sum += z * z;
      }
      return Math.sqrt(sum);
    }
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Math.imul', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(a, b) {
    a = Number(a);
    b = Number(b);
    var ah = a >>> 16 & 65535;
    var al = a & 65535;
    var bh = b >>> 16 & 65535;
    var bl = b & 65535;
    var lh = ah * bl + al * bh << 16 >>> 0;
    return al * bl + lh | 0;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Math.log10', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(x) {
    return Math.log(x) / Math.LN10;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Math.log2', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(x) {
    return Math.log(x) / Math.LN2;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Math.sign', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(x) {
    x = Number(x);
    return x === 0 || isNaN(x) ? x : x > 0 ? 1 : -1;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Math.sinh', function(orig) {
  if (orig) {
    return orig;
  }
  var exp = Math.exp;
  var polyfill = function(x) {
    x = Number(x);
    if (x === 0) {
      return x;
    }
    return (exp(x) - exp(-x)) / 2;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Math.tanh', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(x) {
    x = Number(x);
    if (x === 0) {
      return x;
    }
    var y = Math.exp(-2 * Math.abs(x));
    var z = (1 - y) / (1 + y);
    return x < 0 ? -z : z;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Math.trunc', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(x) {
    x = Number(x);
    if (isNaN(x) || x === Infinity || x === -Infinity || x === 0) {
      return x;
    }
    var y = Math.floor(Math.abs(x));
    return x < 0 ? -y : y;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Number.EPSILON', function(orig) {
  return Math.pow(2, -52);
}, 'es6', 'es3');
$jscomp.polyfill('Number.MAX_SAFE_INTEGER', function() {
  return 9007199254740991;
}, 'es6', 'es3');
$jscomp.polyfill('Number.MIN_SAFE_INTEGER', function() {
  return -9007199254740991;
}, 'es6', 'es3');
$jscomp.polyfill('Number.isFinite', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(x) {
    if (typeof x !== 'number') {
      return false;
    }
    return !isNaN(x) && x !== Infinity && x !== -Infinity;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Number.isInteger', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(x) {
    if (!Number.isFinite(x)) {
      return false;
    }
    return x === Math.floor(x);
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Number.isNaN', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(x) {
    return typeof x === 'number' && isNaN(x);
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Number.isSafeInteger', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(x) {
    return Number.isInteger(x) && Math.abs(x) <= Number.MAX_SAFE_INTEGER;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Number.parseFloat', function(orig) {
  return orig || parseFloat;
}, 'es6', 'es3');
$jscomp.polyfill('Number.parseInt', function(orig) {
  return orig || parseInt;
}, 'es6', 'es3');
$jscomp.assign = typeof Object.assign == 'function' ? Object.assign : function(target, var_args) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];
    if (!source) {
      continue;
    }
    for (var key in source) {
      if ($jscomp.owns(source, key)) {
        target[key] = source[key];
      }
    }
  }
  return target;
};
$jscomp.polyfill('Object.assign', function(orig) {
  return orig || $jscomp.assign;
}, 'es6', 'es3');
$jscomp.polyfill('Object.entries', function(orig) {
  if (orig) {
    return orig;
  }
  var entries = function(obj) {
    var result = [];
    for (var key in obj) {
      if ($jscomp.owns(obj, key)) {
        result.push([key, obj[key]]);
      }
    }
    return result;
  };
  return entries;
}, 'es8', 'es3');
$jscomp.polyfill('Object.getOwnPropertySymbols', function(orig) {
  if (orig) {
    return orig;
  }
  return function() {
    return [];
  };
}, 'es6', 'es5');
$jscomp.polyfill('Reflect.ownKeys', function(orig) {
  if (orig) {
    return orig;
  }
  var symbolPrefix = 'jscomp_symbol_';
  function isSymbol(key) {
    return key.substring(0, symbolPrefix.length) == symbolPrefix;
  }
  var polyfill = function(target) {
    var keys = [];
    var names = Object.getOwnPropertyNames(target);
    var symbols = Object.getOwnPropertySymbols(target);
    for (var i = 0; i < names.length; i++) {
      (isSymbol(names[i]) ? symbols : keys).push(names[i]);
    }
    return keys.concat(symbols);
  };
  return polyfill;
}, 'es6', 'es5');
$jscomp.polyfill('Object.getOwnPropertyDescriptors', function(orig) {
  if (orig) {
    return orig;
  }
  var getOwnPropertyDescriptors = function(obj) {
    var result = {};
    var keys = Reflect.ownKeys(obj);
    for (var i = 0; i < keys.length; i++) {
      result[keys[i]] = Object.getOwnPropertyDescriptor(obj, keys[i]);
    }
    return result;
  };
  return getOwnPropertyDescriptors;
}, 'es8', 'es5');
$jscomp.polyfill('Object.setPrototypeOf', function(orig) {
  return orig || $jscomp.setPrototypeOf;
}, 'es6', 'es5');
$jscomp.polyfill('Object.values', function(orig) {
  if (orig) {
    return orig;
  }
  var values = function(obj) {
    var result = [];
    for (var key in obj) {
      if ($jscomp.owns(obj, key)) {
        result.push(obj[key]);
      }
    }
    return result;
  };
  return values;
}, 'es8', 'es3');
$jscomp.polyfill('Reflect.apply', function(orig) {
  if (orig) {
    return orig;
  }
  var apply = Function.prototype.apply;
  var polyfill = function(target, thisArg, argList) {
    return apply.call(target, thisArg, argList);
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.objectCreate = $jscomp.ASSUME_ES5 || typeof Object.create == 'function' ? Object.create : function(prototype) {
  var ctor = function() {
  };
  ctor.prototype = prototype;
  return new ctor;
};
$jscomp.construct = function() {
  function reflectConstructWorks() {
    function Base() {
    }
    function Derived() {
    }
    new Base;
    Reflect.construct(Base, [], Derived);
    return new Base instanceof Base;
  }
  if (typeof Reflect != 'undefined' && Reflect.construct) {
    if (reflectConstructWorks()) {
      return Reflect.construct;
    }
    var brokenConstruct = Reflect.construct;
    var patchedConstruct = function(target, argList, opt_newTarget) {
      var out = brokenConstruct(target, argList);
      if (opt_newTarget) {
        Reflect.setPrototypeOf(out, opt_newTarget.prototype);
      }
      return out;
    };
    return patchedConstruct;
  }
  function construct(target, argList, opt_newTarget) {
    if (opt_newTarget === undefined) {
      opt_newTarget = target;
    }
    var proto = opt_newTarget.prototype || Object.prototype;
    var obj = $jscomp.objectCreate(proto);
    var apply = Function.prototype.apply;
    var out = apply.call(target, obj, argList);
    return out || obj;
  }
  return construct;
}();
$jscomp.polyfill('Reflect.construct', function(orig) {
  return $jscomp.construct;
}, 'es6', 'es3');
$jscomp.polyfill('Reflect.defineProperty', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(target, propertyKey, attributes) {
    try {
      Object.defineProperty(target, propertyKey, attributes);
      var desc = Object.getOwnPropertyDescriptor(target, propertyKey);
      if (!desc) {
        return false;
      }
      return desc.configurable === (attributes.configurable || false) && desc.enumerable === (attributes.enumerable || false) && ('value' in desc ? desc.value === attributes.value && desc.writable === (attributes.writable || false) : desc.get === attributes.get && desc.set === attributes.set);
    } catch (err) {
      return false;
    }
  };
  return polyfill;
}, 'es6', 'es5');
$jscomp.polyfill('Reflect.deleteProperty', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(target, propertyKey) {
    if (!$jscomp.owns(target, propertyKey)) {
      return true;
    }
    try {
      return delete target[propertyKey];
    } catch (err) {
      return false;
    }
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Reflect.getOwnPropertyDescriptor', function(orig) {
  return orig || Object.getOwnPropertyDescriptor;
}, 'es6', 'es5');
$jscomp.polyfill('Reflect.getPrototypeOf', function(orig) {
  return orig || Object.getPrototypeOf;
}, 'es6', 'es5');
$jscomp.findDescriptor = function(target, propertyKey) {
  var obj = target;
  while (obj) {
    var property = Reflect.getOwnPropertyDescriptor(obj, propertyKey);
    if (property) {
      return property;
    }
    obj = Reflect.getPrototypeOf(obj);
  }
  return undefined;
};
$jscomp.polyfill('Reflect.get', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(target, propertyKey, opt_receiver) {
    if (arguments.length <= 2) {
      return target[propertyKey];
    }
    var property = $jscomp.findDescriptor(target, propertyKey);
    if (property) {
      return property.get ? property.get.call(opt_receiver) : property.value;
    }
    return undefined;
  };
  return polyfill;
}, 'es6', 'es5');
$jscomp.polyfill('Reflect.has', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(target, propertyKey) {
    return propertyKey in target;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Reflect.isExtensible', function(orig) {
  if (orig) {
    return orig;
  }
  if ($jscomp.ASSUME_ES5 || typeof Object.isExtensible == 'function') {
    return Object.isExtensible;
  }
  return function() {
    return true;
  };
}, 'es6', 'es3');
$jscomp.polyfill('Reflect.preventExtensions', function(orig) {
  if (orig) {
    return orig;
  }
  if (!($jscomp.ASSUME_ES5 || typeof Object.preventExtensions == 'function')) {
    return function() {
      return false;
    };
  }
  var polyfill = function(target) {
    Object.preventExtensions(target);
    return !Object.isExtensible(target);
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('Reflect.set', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(target, propertyKey, value, opt_receiver) {
    var property = $jscomp.findDescriptor(target, propertyKey);
    if (!property) {
      if (Reflect.isExtensible(target)) {
        target[propertyKey] = value;
        return true;
      }
      return false;
    }
    if (property.set) {
      property.set.call(arguments.length > 3 ? opt_receiver : target, value);
      return true;
    } else {
      if (property.writable && !Object.isFrozen(target)) {
        target[propertyKey] = value;
        return true;
      }
    }
    return false;
  };
  return polyfill;
}, 'es6', 'es5');
$jscomp.polyfill('Reflect.setPrototypeOf', function(orig) {
  if (orig) {
    return orig;
  } else {
    if ($jscomp.setPrototypeOf) {
      var setPrototypeOf = $jscomp.setPrototypeOf;
      var polyfill = function(target, proto) {
        try {
          setPrototypeOf(target, proto);
          return true;
        } catch (e) {
          return false;
        }
      };
      return polyfill;
    } else {
      return null;
    }
  }
}, 'es6', 'es5');
$jscomp.polyfill('Set', function(NativeSet) {
  function isConformant() {
    if ($jscomp.ASSUME_NO_NATIVE_SET || !NativeSet || typeof NativeSet != 'function' || !NativeSet.prototype.entries || typeof Object.seal != 'function') {
      return false;
    }
    try {
      NativeSet = NativeSet;
      var value = Object.seal({x:4});
      var set = new NativeSet($jscomp.makeIterator([value]));
      if (!set.has(value) || set.size != 1 || set.add(value) != set || set.size != 1 || set.add({x:4}) != set || set.size != 2) {
        return false;
      }
      var iter = set.entries();
      var item = iter.next();
      if (item.done || item.value[0] != value || item.value[1] != value) {
        return false;
      }
      item = iter.next();
      if (item.done || item.value[0] == value || item.value[0].x != 4 || item.value[1] != item.value[0]) {
        return false;
      }
      return iter.next().done;
    } catch (err) {
      return false;
    }
  }
  if ($jscomp.USE_PROXY_FOR_ES6_CONFORMANCE_CHECKS) {
    if (NativeSet && $jscomp.ES6_CONFORMANCE) {
      return NativeSet;
    }
  } else {
    if (isConformant()) {
      return NativeSet;
    }
  }
  $jscomp.initSymbol();
  $jscomp.initSymbolIterator();
  var PolyfillSet = function(opt_iterable) {
    this.map_ = new Map;
    if (opt_iterable) {
      var iter = $jscomp.makeIterator(opt_iterable);
      var entry;
      while (!(entry = iter.next()).done) {
        var item = entry.value;
        this.add(item);
      }
    }
    this.size = this.map_.size;
  };
  PolyfillSet.prototype.add = function(value) {
    value = value === 0 ? 0 : value;
    this.map_.set(value, value);
    this.size = this.map_.size;
    return this;
  };
  PolyfillSet.prototype['delete'] = function(value) {
    var result = this.map_['delete'](value);
    this.size = this.map_.size;
    return result;
  };
  PolyfillSet.prototype.clear = function() {
    this.map_.clear();
    this.size = 0;
  };
  PolyfillSet.prototype.has = function(value) {
    return this.map_.has(value);
  };
  PolyfillSet.prototype.entries = function() {
    return this.map_.entries();
  };
  PolyfillSet.prototype.values = function() {
    return this.map_.values();
  };
  PolyfillSet.prototype.keys = PolyfillSet.prototype.values;
  $jscomp.initSymbol();
  $jscomp.initSymbolIterator();
  PolyfillSet.prototype[Symbol.iterator] = PolyfillSet.prototype.values;
  PolyfillSet.prototype.forEach = function(callback, opt_thisArg) {
    var set = this;
    this.map_.forEach(function(value) {
      return callback.call(opt_thisArg, value, value, set);
    });
  };
  return PolyfillSet;
}, 'es6', 'es3');
$jscomp.checkStringArgs = function(thisArg, arg, func) {
  if (thisArg == null) {
    throw new TypeError("The 'this' value for String.prototype." + func + ' must not be null or undefined');
  }
  if (arg instanceof RegExp) {
    throw new TypeError('First argument to String.prototype.' + func + ' must not be a regular expression');
  }
  return thisArg + '';
};
$jscomp.polyfill('String.prototype.codePointAt', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(position) {
    var string = $jscomp.checkStringArgs(this, null, 'codePointAt');
    var size = string.length;
    position = Number(position) || 0;
    if (!(position >= 0 && position < size)) {
      return void 0;
    }
    position = position | 0;
    var first = string.charCodeAt(position);
    if (first < 55296 || first > 56319 || position + 1 === size) {
      return first;
    }
    var second = string.charCodeAt(position + 1);
    if (second < 56320 || second > 57343) {
      return first;
    }
    return (first - 55296) * 1024 + second + 9216;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('String.prototype.endsWith', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(searchString, opt_position) {
    var string = $jscomp.checkStringArgs(this, searchString, 'endsWith');
    searchString = searchString + '';
    if (opt_position === void 0) {
      opt_position = string.length;
    }
    var i = Math.max(0, Math.min(opt_position | 0, string.length));
    var j = searchString.length;
    while (j > 0 && i > 0) {
      if (string[--i] != searchString[--j]) {
        return false;
      }
    }
    return j <= 0;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('String.fromCodePoint', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(var_args) {
    var result = '';
    for (var i = 0; i < arguments.length; i++) {
      var code = Number(arguments[i]);
      if (code < 0 || code > 1114111 || code !== Math.floor(code)) {
        throw new RangeError('invalid_code_point ' + code);
      }
      if (code <= 65535) {
        result += String.fromCharCode(code);
      } else {
        code -= 65536;
        result += String.fromCharCode(code >>> 10 & 1023 | 55296);
        result += String.fromCharCode(code & 1023 | 56320);
      }
    }
    return result;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('String.prototype.includes', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(searchString, opt_position) {
    var string = $jscomp.checkStringArgs(this, searchString, 'includes');
    return string.indexOf(searchString, opt_position || 0) !== -1;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.polyfill('String.prototype.repeat', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(copies) {
    var string = $jscomp.checkStringArgs(this, null, 'repeat');
    if (copies < 0 || copies > 1342177279) {
      throw new RangeError('Invalid count value');
    }
    copies = copies | 0;
    var result = '';
    while (copies) {
      if (copies & 1) {
        result += string;
      }
      if (copies >>>= 1) {
        string += string;
      }
    }
    return result;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.stringPadding = function(padString, padLength) {
  var padding = padString !== undefined ? String(padString) : ' ';
  if (!(padLength > 0) || !padding) {
    return '';
  }
  var repeats = Math.ceil(padLength / padding.length);
  return padding.repeat(repeats).substring(0, padLength);
};
$jscomp.polyfill('String.prototype.padEnd', function(orig) {
  if (orig) {
    return orig;
  }
  var padEnd = function(targetLength, opt_padString) {
    var string = $jscomp.checkStringArgs(this, null, 'padStart');
    var padLength = targetLength - string.length;
    return string + $jscomp.stringPadding(opt_padString, padLength);
  };
  return padEnd;
}, 'es8', 'es3');
$jscomp.polyfill('String.prototype.padStart', function(orig) {
  if (orig) {
    return orig;
  }
  var padStart = function(targetLength, opt_padString) {
    var string = $jscomp.checkStringArgs(this, null, 'padStart');
    var padLength = targetLength - string.length;
    return $jscomp.stringPadding(opt_padString, padLength) + string;
  };
  return padStart;
}, 'es8', 'es3');
$jscomp.polyfill('String.prototype.startsWith', function(orig) {
  if (orig) {
    return orig;
  }
  var polyfill = function(searchString, opt_position) {
    var string = $jscomp.checkStringArgs(this, searchString, 'startsWith');
    searchString = searchString + '';
    var strLen = string.length;
    var searchLen = searchString.length;
    var i = Math.max(0, Math.min(opt_position | 0, string.length));
    var j = 0;
    while (j < searchLen && i < strLen) {
      if (string[i++] != searchString[j++]) {
        return false;
      }
    }
    return j >= searchLen;
  };
  return polyfill;
}, 'es6', 'es3');
$jscomp.arrayFromIterator = function(iterator) {
  var i;
  var arr = [];
  while (!(i = iterator.next()).done) {
    arr.push(i.value);
  }
  return arr;
};
$jscomp.arrayFromIterable = function(iterable) {
  if (iterable instanceof Array) {
    return iterable;
  } else {
    return $jscomp.arrayFromIterator($jscomp.makeIterator(iterable));
  }
};
$jscomp.inherits = function(childCtor, parentCtor) {
  childCtor.prototype = $jscomp.objectCreate(parentCtor.prototype);
  childCtor.prototype.constructor = childCtor;
  if ($jscomp.setPrototypeOf) {
    var setPrototypeOf = $jscomp.setPrototypeOf;
    setPrototypeOf(childCtor, parentCtor);
  } else {
    for (var p in parentCtor) {
      if (p == 'prototype') {
        continue;
      }
      if (Object.defineProperties) {
        var descriptor = Object.getOwnPropertyDescriptor(parentCtor, p);
        if (descriptor) {
          Object.defineProperty(childCtor, p, descriptor);
        }
      } else {
        childCtor[p] = parentCtor[p];
      }
    }
  }
  childCtor.superClass_ = parentCtor.prototype;
};
$jscomp.polyfill('WeakSet', function(NativeWeakSet) {
  function isConformant() {
    if (!NativeWeakSet || !Object.seal) {
      return false;
    }
    try {
      var x = Object.seal({});
      var y = Object.seal({});
      var set = new NativeWeakSet([x]);
      if (!set.has(x) || set.has(y)) {
        return false;
      }
      set['delete'](x);
      set.add(y);
      return !set.has(x) && set.has(y);
    } catch (err) {
      return false;
    }
  }
  if ($jscomp.USE_PROXY_FOR_ES6_CONFORMANCE_CHECKS) {
    if (NativeWeakSet && $jscomp.ES6_CONFORMANCE) {
      return NativeWeakSet;
    }
  } else {
    if (isConformant()) {
      return NativeWeakSet;
    }
  }
  var PolyfillWeakSet = function(opt_iterable) {
    this.map_ = new WeakMap;
    if (opt_iterable) {
      $jscomp.initSymbol();
      $jscomp.initSymbolIterator();
      var iter = $jscomp.makeIterator(opt_iterable);
      var entry;
      while (!(entry = iter.next()).done) {
        var item = entry.value;
        this.add(item);
      }
    }
  };
  PolyfillWeakSet.prototype.add = function(elem) {
    this.map_.set(elem, true);
    return this;
  };
  PolyfillWeakSet.prototype.has = function(elem) {
    return this.map_.has(elem);
  };
  PolyfillWeakSet.prototype['delete'] = function(elem) {
    return this.map_['delete'](elem);
  };
  return PolyfillWeakSet;
}, 'es6', 'es3');
try {
  if (Array.prototype.values.toString().indexOf('[native code]') == -1) {
    delete Array.prototype.values;
  }
} catch (e) {
}
Ext.define('flextable.Api', {singleton:true, getConnectionInfo:function(moduleId) {
  return this.getStats(moduleId).then(function(statsObject) {
    return (statsObject || {}).connection;
  });
}, getDriverInfo:function(moduleId, params) {
  params = params === undefined ? {mode:'driver'} : params;
  return this.loadInfoData(moduleId, params);
}, getTablesViews:function(moduleId, params) {
  params = params === undefined ? {mode:'tables'} : params;
  return this.loadInfoData(moduleId, params);
}, getSchemas:function(moduleId, params) {
  params = params === undefined ? {mode:'schemas'} : params;
  return this.loadInfoData(moduleId, params);
}, getCatalogs:function(moduleId, params) {
  params = params === undefined ? {mode:'catalogs'} : params;
  return this.loadInfoData(moduleId, params);
}, loadInfoData:function(moduleId, params) {
  return flextable.Support.newRequest(flextable.Support.basePath + moduleId + '/info?' + Ext.Object.toQueryString(params), undefined, undefined).then(function(json) {
    json = json || {};
    var meta = json.meta || {};
    return function() {
      var $jscomp$destructuring$var0 = meta;
      var $jscomp$destructuring$var1 = $jscomp$destructuring$var0;
      connection = $jscomp$destructuring$var1.connection;
      return $jscomp$destructuring$var0;
    }();
  }).then(function(statsObject) {
    return (statsObject || {}).connection;
  });
}, getTableMeta:function(moduleId, tableName) {
  return this.loadInfoData(moduleId, {mode:'tableInfo', table:tableName});
}, getStats:function(moduleId, tableName) {
  var params = {};
  if (tableName) {
    params.table = tableName;
  }
  return flextable.Support.newRequest(flextable.Support.basePath + moduleId + '/info?' + Ext.Object.toQueryString(params), undefined, undefined).then(function(json) {
    json = json || {};
    var meta = json.meta || {};
    return function() {
      var $jscomp$destructuring$var2 = meta;
      var $jscomp$destructuring$var3 = $jscomp$destructuring$var2;
      connection = $jscomp$destructuring$var3.connection;
      return $jscomp$destructuring$var2;
    }();
  });
}});
Ext.define('flextable.widget.Wrapper', {extend:'Ext.panel.Panel', alias:'widget.flextableWidget', mixins:['BpcCommon.mixin.Widget'], statics:{WIDGET_NAME:'Flextable Widget', WIDGET_DESCRIPTION:'TableView -  Main / Details', WIDGET_ICON_CLS:'x-fal fa-table'}, widgetConfigSettingMap:{moduleId:{settingType:'moduleInstance'}}, config:{widgetConfiguration:{moduleId:undefined}}, layout:'card', moduleId:undefined, widgetId:undefined, initComponent:function() {
  try {
    this.initWidgetSettings();
  } catch (e$0) {
  }
  this.callParent(arguments);
  this.initWidget();
  this.settingPanel = this.add({xtype:'bpcSettingPanel', settings:this.settingStore, buttons:[{text:flextable.Support.getTranslation('OK'), handler:this.configureWidget.bind(this)}]});
}, initWidget:function() {
  this.wrapper = this.add(this.moduleId ? {xtype:'flextableMain', moduleId:this.moduleId, isBpcModule:false, showToolbars:false} : {xtype:'container', html:flextable.Support.getTranslation('CONFIG_ERROR_NO_MODULEID_DEFINED'), load:Ext.emptyFn()});
}, refreshWidget:function() {
  this.wrapper.load();
}, configureWidget:function() {
  this.getLayout().setActiveItem(this.settingPanel.isVisible(true) ? this.wrapper : this.settingPanel);
}});
Ext.define('flextable.BpcInterface', {extend:'BpcCommon.BpcInterface', requires:['flextable.widget.Wrapper'], config:{moduleConfigurationComponents:['flextableConfigMain'], requiredModules:[], widgets:['flextable.widget.Wrapper'], version:'3.5.0', build:'v3.3.6-26-g262483f-2022-04-08T12:01:10+0200'}});
Ext.define('flextable.Support', {singleton:true, keys:{cfg:'uiConfiguration', id:'idColumn'}, icons:{instance:'fa-th-list', module:'fa-th-list'}, iconTypePrefix:'x-fal', iconPrefix:'fa-', basePath:'/cxf/bpc-flextable/', getBpcIconCls:function(fontAwesomeName) {
  fontAwesomeName = fontAwesomeName || '';
  fontAwesomeName = fontAwesomeName.trim();
  if (this.isLegacyIconCls(fontAwesomeName)) {
    return 'fa-lg ' + fontAwesomeName;
  }
  if (Ext.String.startsWith(fontAwesomeName, this.iconTypePrefix)) {
    return fontAwesomeName;
  }
  if (!Ext.String.startsWith(fontAwesomeName, this.iconPrefix)) {
    fontAwesomeName = this.iconPrefix + fontAwesomeName;
  }
  return this.iconTypePrefix + ' ' + fontAwesomeName;
}, defaultFontSize:14, defaultFontUnit:'px', fallbackIconColor:'#eee', marginRight:3, isLegacyIconCls:function(fontAwesomeName) {
  var iconClasses = fontAwesomeName.split(' ');
  return iconClasses.length > 0 && iconClasses.indexOf('fa') !== -1;
}, getResponseObject:function(responseObj) {
  responseObj = responseObj || {};
  if ('responseText' in responseObj && responseObj.responseText) {
    return Ext.decode(responseObj.responseText, true);
  } else {
    if ('responseJson' in responseObj && responseObj.responseJson) {
      return responseObj.responseJson;
    }
  }
}, getSpanForIconCls:function(iconCls, color, size) {
  var legacy = this.isLegacyIconCls(iconCls);
  iconCls = this.getBpcIconCls(iconCls);
  size = size || this.defaultFontSize;
  size += this.defaultFontUnit;
  color = color || this.fallbackIconColor;
  var marginRight = this.marginRight;
  var style = 'color:' + color + ';' + (legacy ? '' : 'font-size:' + size + ';') + 'margin-right:' + marginRight + ';';
  return '\x3cspan class\x3d"' + iconCls + '" style\x3d"' + style + '"\x3e\x3c/span\x3e';
}, newRequest:function(url, params, data, method) {
  params = params === undefined ? {} : params;
  data = data === undefined ? null : data;
  method = method === undefined ? 'GET' : method;
  return new Promise(function(resolve, reject) {
    Ext.Ajax.request({url:url, params:params, method:method, jsonData:data, headers:{'Content-Type':'application/json'}, success:function(response) {
      resolve(response.responseText ? Ext.decode(response.responseText, true) : {});
    }, failure:function(response) {
      reject(response);
    }});
  });
}, getTranslation:function(key, uppercase, splitWhitespaceWithBr) {
  key = key.toUpperCase();
  var starter = 'FLEXTABLE_';
  if (!Ext.String.startsWith(key, starter)) {
    key = starter + key;
  }
  var translation = BpcCommon.Api.getTranslation(key);
  if (key === translation) {
  }
  translation = uppercase ? translation.toUpperCase() : translation;
  return splitWhitespaceWithBr ? translation.replace(' ', '\x3cbr\x3e') : translation;
}, getWindow:function(title, iconCls, width, height, cmpAlias, cmpConfig) {
  var w = Ext.create('Ext.window.Window', {title:title || '', height:height || document.body.clientHeight * 0.8, width:width || document.body.clientWidth * 0.6, layout:'fit', iconCls:flextable.Support.getBpcIconCls(iconCls || 'fa-info')});
  cmpConfig = cmpConfig || {};
  cmpConfig.windowReference = w;
  cmpConfig.closeWindow = function() {
    w.close();
  };
  w.add(Ext.create(Ext.apply({xtype:cmpAlias}, cmpConfig)));
  return w;
}, resourcesBasePath:'/bpc-fe-flextable/', getAjaxPromise:function(requestOptions) {
  return new Promise(function(resolve, reject) {
    Ext.Ajax.request(requestOptions).then(function(response) {
      resolve(response);
    }, function(error) {
      reject(error);
    });
  });
}, copyToClipBoard:function(text, extCmp) {
  function copyToClp(stringWithNewLines) {
    try {
      var myFluffyTextarea = document.createElement('textarea');
      myFluffyTextarea.innerHTML = stringWithNewLines;
      var parentElement = document.getElementById(extCmp.getId());
      parentElement.appendChild(myFluffyTextarea);
      myFluffyTextarea.select();
      document.execCommand('copy');
      parentElement.removeChild(myFluffyTextarea);
      return true;
    } catch (e$1) {
      return false;
    }
  }
  return copyToClp(text);
}, getBackendConnectionId:function(instanceId) {
  return BpcCommon.Api.getSetting(instanceId, 'proxyId');
}, mimeTypeMap:{'application/pdf':'fa-file-pdf', 'text/plain':'fa-file-alt', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document':'fa-file-word', 'application/xml':'fa-file-code', 'text/xml':'fa-file-code', 'application/edifact':'fa-file-code', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet':'fa-file-excel', 'other':'fa-file'}, prettyXml:function(xml, tab, nl) {
  tab = tab === undefined ? '\t' : tab;
  nl = nl === undefined ? '\n' : nl;
  var formatted = '', indent = '';
  var nodes = xml.slice(1, -1).split(/>\s*</);
  if (nodes[0][0] === '?') {
    formatted += '\x3c' + nodes.shift() + '\x3e' + nl;
  }
  for (var i = 0; i < nodes.length; i++) {
    var node = nodes[i];
    if (node[0] === '/') {
      indent = indent.slice(tab.length);
    }
    formatted += indent + '\x3c' + node + '\x3e' + nl;
    if (node[0] !== '/' && node[node.length - 1] !== '/' && node.indexOf('\x3c/') === -1) {
      indent += tab;
    }
  }
  return formatted;
}, objectToHtmlTable:function(obj, keys, trPrefix) {
  keys = keys === undefined ? [] : keys;
  trPrefix = trPrefix === undefined ? '' : trPrefix;
  obj = obj || {};
  var html = '\x3ctable style\x3d"width: 300px"\x3e';
  Object.keys(obj).filter(function(k) {
    return keys.length ? keys.indexOf(k) !== -1 : true;
  }).map(function(k) {
    html += '\x3ctr\x3e';
    html += '\x3ctd style\x3d"width: 120px"\x3e' + (trPrefix.length ? documents.Support.TR(trPrefix + k) : k) + '\x3c/td\x3e';
    html += '\x3ctd style\x3d"width: 180px"\x3e' + obj[k] + '\x3c/td\x3e';
    html += '\x3c/tr\x3e';
  });
  return html + '\x3c/table\x3e';
}, preloadPluginModules:function(moduleId) {
  var $jscomp$this = this;
  var deferred = new Ext.Deferred;
  var cfg = BpcCommon.Api.getSetting('flextable', 'plugin_configuration') || [];
  var sourceModuleNames = cfg.filter(function(cfg) {
    return Ext.isDefined(cfg.sourceModule) && cfg.sourceModule !== null;
  }).map(function(cfg) {
    return cfg.sourceModule;
  });
  sourceModuleNames = Ext.Array.unique(sourceModuleNames);
  var pluginSettingValuesForModuleId = moduleId ? cfg.filter(function(settingsValue) {
    return settingsValue.targetInstance && Ext.isArray(settingsValue.targetInstance) && settingsValue.targetInstance.indexOf(moduleId) !== -1;
  }) : [];
  if (this.pluginMap[moduleId]) {
    var settings = this.pluginMap[moduleId];
    deferred.resolve(JSON.parse(JSON.stringify(settings)));
  } else {
    var moduleLoadPromises = sourceModuleNames.map(function(moduleName) {
      return BpcCommon.Api.loadModule(moduleName);
    });
    Promise.all(moduleLoadPromises).then(function() {
      $jscomp$this.pluginMap[moduleId] = pluginSettingValuesForModuleId;
      deferred.resolve(pluginSettingValuesForModuleId);
    }, function() {
      deferred.resolve(false);
    });
  }
  return deferred.promise;
}, pluginMap:{}, pluginsLoaded:false, getPlugins:function(instanceId) {
  var pluginConfigurations = BpcCommon.Api.getSetting('flextable', 'plugin_configuration') || [];
  return pluginConfigurations.filter(function(conf) {
    return Ext.isDefined(conf.targetInstance) && Ext.isArray(conf.targetInstance) && conf.targetInstance.indexOf(instanceId) !== -1;
  });
}});
Ext.define('flextable.components.DetailPanel', {extend:'Ext.panel.Panel', alias:'widget.flextableDetailPanel', layout:{type:'vbox', align:'stretch'}, header:false, initComponent:function() {
  var defaults = {record:this.record, moduleInstance:this.moduleInstance};
  var processViewer = {xtype:'container', layout:{type:'hbox', align:'stretch'}, record:undefined, moduleInstance:undefined, createItemView:function() {
    var me = this;
    return me.add({xtype:'fieldset', flex:1, layout:{type:'vbox', align:'stretch'}, title:flextable.Support.getTranslation('INFORMATIONS'), record:me.record, moduleInstance:me.moduleInstance, getFlexItem:function(rawKey, rawValue) {
      var me = this;
      rawKey = rawKey || '';
      rawValue = rawValue || '';
      if (me.moduleInstance) {
        var columns = me.moduleInstance.getColumn(rawKey);
        if (columns.length && columns[0].renderer) {
          rawValue = columns[0].renderer(rawValue);
          rawKey = columns[0].text || rawKey;
        }
      }
      return '\x3cdiv style\x3d"display: flex; flex-direction: row"\x3e\x3cdiv style\x3d"flex-grow: 1;max-width: 15%"\x3e' + rawKey + ': \x3c/div\x3e\x3cdiv style\x3d"flex-grow: 3"\x3e' + rawValue + '\x3c/div\x3e\x3c/div\x3e';
    }, addItemsFromRecord:function() {
      var me = this;
      var obj = me.record.getData() || {};
      Object.keys(obj).filter(function(k) {
        return k !== 'R__' && k !== 'id';
      }).map(function(key) {
        me.add({xtype:'box', html:me.getFlexItem(key, obj[key])});
      });
    }});
  }, flex:1};
  var containerBase = {xtype:'container', layout:'fit', items:[], flex:1};
  this.topContainer = Ext.create(Ext.apply({}, containerBase, defaults));
  this.mainContainer = Ext.create(Ext.apply({}, containerBase, defaults));
  this.items = [this.topContainer, {xtype:'splitter'}, this.mainContainer];
  this.callParent(arguments);
  var processViewerCmp = this.topContainer.add(Ext.apply(processViewer, defaults));
  processViewerCmp.createItemView().addItemsFromRecord();
  var tabPanel = this.mainContainer.add({xtype:'tabpanel'});
  var detailGrid = tabPanel.add({xtype:'flextableGrid', moduleId:this.moduleId, moduleInstance:this.moduleInstance, mode:'details', title:flextable.Support.getTranslation('LOG_STEPS')});
  tabPanel.setActiveTab(detailGrid);
  detailGrid.changeExtraParams({idValue:this.record.get(BpcCommon.Api.getSetting(this.moduleId, flextable.Support.keys.id))});
  detailGrid.store.load();
}});
Ext.define('flextable.components.Grid', {extend:'Ext.grid.Panel', alias:'widget.flextableGrid', moduleId:undefined, columns:undefined, idKey:undefined, flexContext:undefined, openDetailWindow:function(rec) {
  var w = flextable.Support.getWindow(rec.get(BpcCommon.Api.getSetting(this.moduleId, flextable.Support.keys.id)), undefined, undefined, undefined, 'flextableDetailPanel', {record:rec, moduleId:this.moduleId, moduleInstance:this.moduleInstance});
  w.show();
}, getActionColumn:function() {
  return {xtype:'actioncolumn', width:50, items:[]};
}, connectionDetails:{}, initComponent:function() {
  var $jscomp$this = this;
  this.totalBtn = Ext.create({xtype:'button', iconCls:flextable.Support.getBpcIconCls('fa-database'), text:'0', listeners:{afterRender:function(b) {
    if (BpcCommon.Api.hasUserAnyRole(['bpcadmin'])) {
      Ext.create({xtype:'tooltip', target:b, listeners:{beforeshow:function(tip) {
        tip.setHtml(flextable.Support.objectToHtmlTable($jscomp$this.connectionDetails));
      }}});
    }
  }}});
  var listeners = {};
  this.viewConfig = {emptyText:flextable.Support.getTranslation('NO_DATA'), enableTextSelection:true};
  var fieldsDefinition = [];
  if (this.mode === 'details') {
    var idFieldForDetails = BpcCommon.Api.getSetting(this.moduleId, 'idColumnDetailSub');
    fieldsDefinition.push({name:idFieldForDetails, sortType:'asInt'});
  }
  this.store = Ext.create('Ext.data.Store', {fields:fieldsDefinition, proxy:{type:'ajax', url:'/cxf/bpc-flextable/' + this.moduleId + '/data', reader:{type:'json', rootProperty:'items', totalProperty:'total'}, listeners:{exception:function(p, response, operation) {
    $jscomp$this.handleError(Ext.decode(response.responseText, true));
  }}}, autoLoad:false, _grid:this, columnsAdded:undefined, listeners:{load:function(store, records, success, operation) {
    if (success) {
      if (!store.columnsAdded) {
        $jscomp$this.setColumnsFromRecord(records.length ? records[0] : Ext.create('Ext.data.Model', {NO_DATA:undefined}));
      }
      $jscomp$this.updateTotal();
      var response = operation.getResponse();
      var json = flextable.Support.getResponseObject(response);
      if (json && json.meta && json.meta.connection) {
        $jscomp$this.connectionDetails = json.meta.connection;
      }
    } else {
      if (!store.columnsAdded) {
        $jscomp$this.setColumnsFromRecord(Ext.create('Ext.data.Model', {NO_DATA:undefined}));
      }
    }
  }}});
  var definedColumns = this.getColumnsFromSetting(this.mode || 'main');
  var columns = definedColumns ? this.getActionColumnConfig(this.moduleId).concat(definedColumns) : undefined;
  var actionColumn = this.getActionColumn();
  var pluginDefinitions = this.getPluginDefinitions();
  if (pluginDefinitions && pluginDefinitions.length) {
    var instances = pluginDefinitions.map(function(i) {
      return Ext.create(i);
    });
    if (instances.length === 1) {
      var o = instances[0].getPluginAction(this);
      if (o) {
        actionColumn.items.push(o);
      }
    }
  }
  var actionColPrefix = BpcCommon.Api.getSetting(this.moduleId, 'actionColumnPrefix');
  var actionListener = BpcCommon.Api.getSetting(this.moduleId, 'actionListener');
  var actionActive = actionListener !== null && actionListener !== undefined;
  if (actionActive) {
    actionColumn.items.push({iconCls:flextable.Support.getBpcIconCls('fa-play'), tooltip:'Aktionen starten', handler:function(grid, rowIndex, colIndex, item, e, record) {
      var actions = [];
      var actionColumns = Object.keys(record.data).filter(function(i) {
        if (i && Ext.isString(i)) {
          return i.startsWith(actionColPrefix);
        }
        return false;
      }).map(function(name) {
        var actionString = record.get(name);
        actionString.split(',').map(function(i) {
          i = i || '';
          return i.trim();
        }).filter(function(i) {
          return i.length > 0;
        }).map(function(i) {
          actions.push({text:i});
        });
      });
      Ext.create('Ext.menu.Menu', {margin:'0 0 10 0', floating:true, items:actions.map(function(i) {
        i.record = record;
        i.iconCls = flextable.Support.getBpcIconCls('fa-play-circle');
        i.handler = function(m) {
          $jscomp$this.runAction(m.text, m.record);
        };
        return i;
      })}).showAt(e.getXY());
    }, isActionDisabled:function(view, rowIndex, colIndex, item, record) {
      if (record && record.data) {
        var actionColumns = Object.keys(record.data).filter(function(i) {
          if (i && Ext.isString(i)) {
            return i.startsWith(actionColPrefix);
          }
          return false;
        });
        return actionColumns.length === 0;
      }
      return true;
    }});
  }
  if (actionColumn.items.length && columns) {
    actionColumn.width = actionColumn.items.length * 30;
    columns.push(actionColumn);
  }
  this.columns = columns;
  listeners.rowdblclick = function(tableView, record) {
    if ($jscomp$this.moduleInstance.isBpcModule && $jscomp$this.mode !== 'details') {
      $jscomp$this.openDetailWindow(record);
    } else {
      if (!$jscomp$this.moduleInstance.isBpcModule && $jscomp$this.mode === 'details' && $jscomp$this.getAttachment(record)) {
        $jscomp$this.openAttachment(record);
      }
    }
  };
  this.plugins = this.idKey ? [{ptype:'rowwidget', widget:{xtype:'container', layout:'fit', items:[]}, _grid:this, onWidgetAttach:function(plugin, cmp, record) {
    cmp.removeAll();
    var gridCmp = cmp.add({xtype:'flextableGrid', moduleId:plugin._grid.moduleId, moduleInstance:plugin._grid.moduleInstance, mode:'details'});
    var pid = record.get(plugin._grid.idKey);
    if (pid) {
      gridCmp.changeExtraParams({idValue:pid});
      gridCmp.store.load();
    }
  }}] : [];
  this.store.columnsAdded = !!(Ext.isDefined(this.columns) && this.columns.length);
  if (!Ext.isDefined(this.columns)) {
    this.columns = [];
  }
  if (this.moduleInstance.showToolbars) {
    this.bbar = [this.totalBtn, {xtype:'tbfill'}];
  }
  this.listeners = listeners;
  this.callParent(arguments);
}, getEngineBaseUrl:function() {
  var proxyId = BpcCommon.Api.getSetting(this.moduleId, 'engineConnection');
  return BpcCommon.Api.getBackendUrl(proxyId) + BpcCommon.Api.getSetting(this.moduleId, 'engineBasePath');
}, runAction:function(action, record) {
  var cfg = BpcCommon.Api.getSetting(this.moduleId, 'actionConfig') || {};
  var urlParams = {}, url = this.getEngineBaseUrl() + BpcCommon.Api.getSetting(this.moduleId, 'actionListener');
  if (cfg.params && Ext.isObject(cfg.params) && !Ext.isEmpty(cfg.params)) {
    urlParams = Ext.apply(urlParams, cfg.params);
  }
  var actionPrefix = BpcCommon.Api.getSetting(this.moduleId, 'actionColumnPrefix');
  actionPrefix = actionPrefix || '';
  actionPrefix = actionPrefix.toLowerCase();
  urlParams[actionPrefix] = action;
  urlParams.buttonId = actionPrefix;
  url += '?' + Ext.Object.toQueryString(urlParams);
  var data = record.data || {};
  data.tablePrefix = BpcCommon.Api.getSetting(this.moduleId, 'tableNameDetails');
  return Ext.Ajax.request({url:url, headers:{ISPortalUser:BpcCommon.Api.getUserName(), 'X-BPC-ModuleId':this.moduleId}, method:'POST', params:data}).then(function(response) {
    var json = flextable.Support.getResponseObject(response);
    if (json) {
      if (json.success) {
        BpcCommon.Api.showNotification(json.message ? json.message : 'Aktion wurde erfolgreich ausgeführt');
      } else {
        BpcCommon.Api.showNotification(json.message ? json.message : 'Fehler bei der Ausführung der Aktion');
      }
    } else {
      BpcCommon.Api.showNotification('Action: ' + action + ' - Fehler bei der Ausführung - Response Unexpected');
    }
  }, function(response) {
    BpcCommon.Api.showNotification('Action: ' + action + ' - Fehler bei der Ausführung');
  });
}, handleError:function(obj) {
  var v = this.getView();
  if (v) {
    v.setEmptyText(obj && obj.error || ' - ');
  }
}, getAttachmentDataIndex:function() {
  return BpcCommon.Api.getSetting(this.moduleId, 'fileColumn') || 'REFERENCE';
}, getAttachment:function(record) {
  var fileDataIndex = this.getAttachmentDataIndex();
  return record.get(fileDataIndex) || record.get(fileDataIndex.toUpperCase());
}, openAttachment:function(record) {
  var $jscomp$this = this;
  try {
    var r = record;
    var w = this.up('window'), t = undefined, idSuffix = 'fileViewerItemId';
    if (w) {
      t = w.down('tabpanel');
      if (t) {
        var params = flextable.file.getFileParameters(record, this.moduleId);
        var openViewer = t.down('#' + idSuffix + params.childid);
        if (openViewer) {
          t.setActiveTab(openViewer);
          return;
        }
      } else {
        return;
      }
    }
    var v = this.getView();
    v.setLoading(true);
    var wrapper, title = '', openAsTab = !!t;
    flextable.file.getFile(r, this.moduleId).then(function(data) {
      if (data) {
        wrapper = flextable.file.getViewer($jscomp$this.moduleId, data);
        if ($jscomp$this.moduleInstance.fileViewerMetaHidden) {
          wrapper.metaField.setVisible(false);
        }
        title = data.meta.childid ? flextable.Support.getTranslation('DOCUMENT_FROM_STEP') + ': ' + data.meta.childid : flextable.Support.getTranslation('DOCUMENT_PREVIEW');
      } else {
      }
    })['catch'](function(e) {
      title = flextable.Support.getTranslation('REQUEST_ERROR');
      var storeData = ['status', 'statusText', 'responseText'].map(function(k) {
        return {key:flextable.Support.getTranslation('ERROR_INFO_REQUEST_' + k.toUpperCase()), value:e[k] || '-1'};
      });
      if (e.request && e.request.url) {
        storeData.push({key:flextable.Support.getTranslation('ERROR_INFO_REQUEST_URL'), value:e.request.url});
      }
      wrapper = $jscomp$this.getErrorPanel(title, storeData, openAsTab);
    })['finally'](function() {
      v.setLoading(false);
      if (t) {
        t.add(wrapper);
        t.setActiveTab(wrapper);
      } else {
        Ext.create('Ext.window.Window', {title:title, height:document.body.clientHeight * 0.5, width:document.body.clientWidth * 0.7, iconCls:flextable.Support.getBpcIconCls('fa-file'), layout:'fit', items:[wrapper]}).show();
      }
    });
  } catch (e$2) {
  }
}, getErrorPanel:function(title, data, openAsTab) {
  data = data === undefined ? [] : data;
  return Ext.create({xtype:'panel', title:title, header:openAsTab, closable:openAsTab, iconCls:flextable.Support.getBpcIconCls('fa-exclamation-triangle'), layout:'fit', items:[{xtype:'grid', header:false, listeners:{rowdblclick:function(tableView, record) {
    if (flextable.Support.copyToClipBoard(record.get('value'), tableView)) {
      BpcCommon.Api.showNotification(record.get('key') + ' ' + flextable.Support.getTranslation('COPIED_SUCCESS'));
    }
  }}, store:Ext.create('Ext.data.Store', {data:data}), columns:[{dataIndex:'key', text:flextable.Support.getTranslation('KEY'), flex:1, menuDisabled:true}, {dataIndex:'value', text:flextable.Support.getTranslation('VALUE'), flex:3, menuDisabled:true}]}]});
}, getActionColumnConfig:function(moduleId) {
  var $jscomp$this = this;
  var mimetypeDataIndex = 'MIMETYPE', defaultMimetype = 'application/xml';
  var items = [{tooltip:flextable.Support.getTranslation('SHOW_DOCUMENT'), scope:this, handler:function(g, r, c, i, e, record) {
    $jscomp$this.openAttachment(record);
  }, isActionDisabled:function(view, rowIndex, colIndex, item, record) {
    return !$jscomp$this.getAttachment(record);
  }, getClass:function(value, metadata, record) {
    var mimeType = record.get(mimetypeDataIndex) || defaultMimetype;
    return flextable.Support.getBpcIconCls(flextable.Support.mimeTypeMap[mimeType] || 'fa-file');
  }}, {iconCls:flextable.Support.getBpcIconCls('fa-download'), tooltip:flextable.Support.getTranslation('DOWNLOAD_DOCUMENT'), handler:function(grid, row, c, i, e, r) {
    try {
      flextable.file.openFile(r, moduleId);
    } catch (e$3) {
      BpcCommon.Api.showNotification(flextable.Support.getTranslation('DOWNLOAD_ERROR'));
    }
  }, isActionDisabled:function(view, rowIndex, colIndex, item, record) {
    return !$jscomp$this.getAttachment(record);
  }}];
  return [{xtype:'actioncolumn', width:items.length * 30, items:items}];
}, createRenderer:function(cfg) {
  cfg = cfg || {};
  var isDate = Ext.isDefined(cfg.isDate) ? cfg.isDate : false;
  if (isDate) {
    var dateCfg = cfg;
    return function(v, m, r) {
      if (!v) {
        return '';
      }
      var rendererValue;
      if (dateCfg.autoParse === false) {
        var date = dateCfg.formatInput ? Ext.Date.parse(v, dateCfg.formatInput) : Ext.Date.parse(v);
        if (Ext.isDate(date)) {
          rendererValue = Ext.Date.format(date, dateCfg.format);
        } else {
          var splitted = v.split('+');
          if (splitted.length === 2) {
            var tzArray = splitted[1].split(':');
            if (tzArray[0].length === 1) {
              tzArray[0] = '0' + tzArray[0];
            }
            var timeZone = tzArray.join(':');
            var newDateString = splitted[0].trim() + '+' + timeZone;
            newDateString = newDateString.trim();
            var date2 = Ext.Date.parse(newDateString);
            if (date2) {
              rendererValue = Ext.Date.format(date2, dateCfg.format || 'd.m.Y');
            }
          }
        }
      }
      return rendererValue ? rendererValue : v || '';
    };
  }
  var iconOnly = Ext.isDefined(cfg.iconOnly) ? cfg.iconOnly : false;
  var map = cfg.valueMap || {};
  var renderIcon = function(cls, c) {
    return cls ? flextable.Support.getSpanForIconCls(cls, c) : undefined;
  };
  var compareLower = Ext.isDefined(cfg.compareLower) ? cfg.compareLower : false;
  return function(v, m, r) {
    var rendererValue;
    v = v || '';
    v = compareLower ? v.toLowerCase() : v;
    if (map[v]) {
      var item = map[v] || {};
      item = Ext.applyIf(item, {label:undefined, iconOnly:undefined, color:undefined});
      rendererValue = iconOnly ? renderIcon(item.iconCls, item.color) : (renderIcon(item.iconCls, item.color) || '') + ' ' + (item.label || v || '');
    }
    return rendererValue ? rendererValue : v;
  };
}, getColumnsFromSetting:function(mainOrDetails) {
  var $jscomp$this = this;
  var cfg = BpcCommon.Api.getSetting(this.moduleId, 'uiConfiguration') || {};
  var rendererCfg = cfg.renderer || {};
  if (cfg[mainOrDetails] && cfg[mainOrDetails].columns) {
    return cfg[mainOrDetails].columns.map(function(colCfg) {
      try {
        var renderer = colCfg.dataIndex && rendererCfg[colCfg.dataIndex] ? $jscomp$this.createRenderer(rendererCfg[colCfg.dataIndex] || {}) : undefined;
        if (renderer) {
          colCfg.renderer = renderer;
        }
      } catch (e$4) {
      }
      return colCfg;
    });
  }
}, changeExtraParams:function(params) {
  var p = this.store.getProxy().getExtraParams() || {};
  p = Ext.apply(p, params);
  this.store.getProxy().setExtraParams(p);
  this.store.load();
}, setColumnsFromRecord:function(rec) {
  var obj = rec ? rec.getData() : {};
  var columns = Object.keys(obj).filter(function(name) {
    return name !== 'id';
  }).map(function(name) {
    return {dataIndex:name, text:name, flex:1};
  });
  this.reconfigure(columns);
  this.store.addColumns = true;
}, updateTotal:function(num) {
  var total = num || this.store.getTotalCount();
  this.totalBtn.setText(String(total) + ' ' + flextable.Support.getTranslation('ROWS'));
}, getPluginDefinitions:function() {
  var h = Ext.createByAlias('widget.flextableGridActionHook', {hidden:true, context:{moduleId:'flextable', instanceId:this.moduleId}});
  return h.getPluginDefinitions();
}});
Ext.define('flextable.file', {singleton:true, getFileParameters:function(record, moduleId) {
  return {directory:record.get(BpcCommon.Api.getSetting(moduleId, 'fileColumn')) || null, processid:record.get(BpcCommon.Api.getSetting(moduleId, 'idColumnDetail')) || null, childid:record.get(BpcCommon.Api.getSetting(moduleId, 'idColumnDetailSub')) || null, prefix:BpcCommon.Api.getSetting(moduleId, 'tablePrefix') || null, mime:record.get(BpcCommon.Api.getSetting(moduleId, 'fileMimeColumn')) || null};
}, getFileUrl:function(record, moduleId) {
  var params = this.getFileParameters(record, moduleId);
  var proxyId = BpcCommon.Api.getSetting(moduleId, 'engineConnection') || '-1';
  var basePath = BpcCommon.Api.getSetting(moduleId, 'engineBasePath') || '';
  var fileListener = BpcCommon.Api.getSetting(moduleId, 'fileListener') || '';
  var prefix = BpcCommon.Api.getBackendUrl(proxyId) || '';
  return prefix + basePath + fileListener + '?' + Ext.Object.toQueryString(params);
}, getFileResponse:function(url) {
  return flextable.Support.getAjaxPromise({method:'get', url:url});
}, getFile:function(record, moduleId) {
  var url = this.getFileUrl(record, moduleId);
  return this.getFileResponse(url).then(function(response) {
    if (response && response.responseText) {
      return {file:response.responseText, meta:flextable.file.getFileParameters(record, moduleId), record:record, fileSource:response.responseText, fileUrl:url};
    }
  });
}, openFile:function(record, moduleId) {
  window.open(this.getFileUrl(record, moduleId), '_blank');
}, getViewer:function(moduleId, data, idSuffix) {
  data = data === undefined ? {} : data;
  idSuffix = idSuffix === undefined ? 'fileViewerItemId' : idSuffix;
  var fileData = data.file || '';
  if (data.meta.mime) {
    data.meta.forceViewUrl = ['image/png', 'image/jpeg', 'image/bmp', 'image/gif', 'image/jpg', 'application/pdf'].indexOf(data.meta.mime) !== -1;
    data.meta.isXml = data.file.trim().startsWith('\x3c');
  } else {
    fileData = fileData.trim();
    if (fileData.startsWith('\x3c')) {
      data.meta.mime = 'text/xml';
      data.meta.isXml = true;
      data.meta.mimeGuess = true;
    } else {
      if (fileData.split("'").length > 2) {
        data.meta.mime = 'application/edifact';
        data.meta.mimeGuess = true;
      }
    }
  }
  if (data.meta.isXml) {
    data.file = flextable.Support.prettyXml(fileData);
    data.treeView = Ext.create({xtype:'ftTree', fileSource:data.fileSource});
  } else {
    if (data.meta.mime === 'application/edifact') {
      data.file = fileData.split("'").map(function(i) {
        return i.trim();
      }).join("'\r\n");
    } else {
      if (fileData.split("'").length > 2) {
        data.file = fileData.split("'").map(function(i) {
          return i.trim();
        }).join("'\r\n");
      }
    }
  }
  return Ext.create({xtype:'ftFileViewer', moduleId:moduleId, idSuffix:idSuffix, fileObject:data});
}});
Ext.define('flextable.components.fileViewer.FileViewer', {extend:'Ext.panel.Panel', alias:'widget.ftFileViewer', closable:true, iconCls:flextable.Support.getBpcIconCls('fa-file'), header:false, layout:'card', moduleId:undefined, idSuffix:undefined, fileObject:{}, showNotification:function(msg, level) {
  var $jscomp$this = this;
  level = level === undefined ? 'i' : level;
  this.notificationField.update(msg);
  Ext.defer(function() {
    $jscomp$this.notificationField.update('');
  }, 2000);
}, initComponent:function() {
  var $jscomp$this = this;
  this.itemId = this.idSuffix + this.fileObject.meta.childid;
  this.title = this.fileObject.meta.childid ? flextable.Support.getTranslation('DOCUMENT_FROM_STEP') + ': ' + this.fileObject.meta.childid : flextable.Support.getTranslation('DOCUMENT_PREVIEW');
  this.notificationField = Ext.create({xtype:'container'});
  if (this.fileObject.meta) {
    this.metaView = this.createMetaViewer();
  }
  this.metaField = Ext.create({text:flextable.Support.getTranslation('META'), ui:'secondary', xtype:'button', margin:'0 0 0 0', handler:function(b) {
    $jscomp$this.setActiveCard($jscomp$this.metaView);
  }});
  this.dockedItems = [{xtype:'toolbar', dock:'top', padding:'3 0 3 0', items:[{text:'HTML', disabled:true, hidden:true}, {text:flextable.Support.getTranslation('ORIGINAL'), iconCls:flextable.Support.getBpcIconCls('fa-file'), margin:'0 2 0 0', ui:'primary', overCls:'', focusCls:'', handler:function() {
    $jscomp$this.setActiveCard($jscomp$this.baseViewer.displayText());
  }}, {text:flextable.Support.getTranslation('FORMAT'), iconCls:flextable.Support.getBpcIconCls('fa-align-justify'), ui:'primary', margin:'0 2 0 0', overCls:'', focusCls:'', handler:function() {
    $jscomp$this.setActiveCard($jscomp$this.baseViewer.displayText('formatted'));
  }}, {text:flextable.Support.getTranslation('TREEVIEW'), iconCls:flextable.Support.getBpcIconCls('fa-folder-tree'), ui:'primary', margin:'0 2 0 0', hidden:!this.fileObject.meta.isXml, overCls:'', focusCls:'', handler:function() {
    $jscomp$this.setActiveCard($jscomp$this.fileObject.treeView);
  }}, {xtype:'tbfill'}, this.notificationField, {xtype:'tbfill'}, {iconCls:flextable.Support.getBpcIconCls('fa-copy'), text:flextable.Support.getTranslation('COPY'), ui:'secondary', margin:'0 2 0 0', handler:function(b) {
    var card = $jscomp$this.getLayout().getActiveItem();
    if (card.getValue) {
      if (flextable.Support.copyToClipBoard(card.getValue(), card)) {
        $jscomp$this.showNotification(flextable.Support.getTranslation('COPIED_SUCCESS'));
      }
    }
  }}, {iconCls:flextable.Support.getBpcIconCls('fa-download'), text:flextable.Support.getTranslation('DOWNLOAD'), ui:'secondary', margin:'0 2 0 0', disabled:!Ext.isDefined(this.moduleId) || this.moduleId === null, handler:function() {
    flextable.file.openFile($jscomp$this.fileObject.record, $jscomp$this.moduleId);
  }}, this.metaField]}];
  this.baseViewer = this.createBaseViewer();
  this.items = [this.baseViewer];
  this.callParent(arguments);
}, setActiveCard:function(card) {
  this.getLayout().setActiveItem(card);
}, createBaseViewer:function() {
  var textView = Ext.create({xtype:'ftText', value:this.fileObject.file ? this.fileObject.file : this.fileObject.fileSource || '-1', readOnly:true});
  return Ext.create({xtype:'container', itemId:'flexFileView', layout:'fit', fileData:this.fileObject, items:[textView], getValue:function() {
    return textView.getValue();
  }, displayText:function(mode) {
    mode = mode === undefined ? 'original' : mode;
    if (mode === 'original') {
      textView.setValue(this.fileData.fileSource || '-1');
    } else {
      if (mode === 'formatted') {
        textView.setValue(this.fileData.file || '-1');
      }
    }
    return this;
  }});
}, createMetaViewer:function() {
  this.metaView = Ext.create({xtype:'ftFileMeta', fileObject:this.fileObject, viewer:this});
  return this.metaView;
}});
Ext.define('flextable.components.fileViewer.Meta', {extend:'Ext.panel.Panel', alias:'widget.ftFileMeta', moduleId:undefined, fileObject:{}, header:false, flex:1, layout:'fit', hidden:true, scrollable:true, initComponent:function() {
  var metaObject = this.fileObject.meta || {};
  var $jscomp$destructuring$var4 = metaObject;
  var directory = $jscomp$destructuring$var4.directory;
  directory = directory || '';
  var filename = this.getFileNameFromDirectory(directory);
  if (filename) {
    this.updateNotificationField(flextable.Support.getTranslation('FILE') + ': ' + filename);
    metaObject.filename = filename;
  }
  var storeData = Object.keys(metaObject).map(function(k) {
    return {key:k.toUpperCase(), value:metaObject[k] || ''};
  });
  this.items = [{xtype:'grid', store:Ext.create('Ext.data.Store', {data:storeData}), listeners:{rowdblclick:function(tv, rec) {
    var textValue = rec.get('value') || '';
    if (textValue.length > 0 && flextable.Support.copyToClipBoard(textValue, tv)) {
      BpcCommon.Api.showNotification(textValue + ' ' + flextable.Support.getTranslation('COPIED_SUCCESS'));
    }
  }}, columns:[{dataIndex:'key', renderer:function(v) {
    v = v || '';
    return v.length ? '\x3cb\x3e' + v + '\x3c/b\x3e' : v;
  }}, {dataIndex:'value', flex:1}, {xtype:'actioncolumn', width:40, items:[{iconCls:flextable.Support.getBpcIconCls('fa-clone'), tooltip:flextable.Support.getTranslation('COPY'), handler:function(tv, row, c, i, e, r) {
    var textValue = r.get('value') || '';
    if (textValue.length > 0 && flextable.Support.copyToClipBoard(textValue, tv)) {
      BpcCommon.Api.showNotification(textValue + ' ' + flextable.Support.getTranslation('COPIED_SUCCESS'));
    }
  }}]}]}];
  this.callParent(arguments);
}, updateNotificationField:function(str) {
  this.viewer.notificationField.update(str);
}, getFileNameFromDirectory:function(dir) {
  dir = dir === undefined ? '' : dir;
  if (dir.indexOf(':') !== -1) {
    var parts = dir.split(':');
    if (parts.length > 1) {
      var filePart = parts[1] || '';
      if (filePart.indexOf('/') !== -1) {
        var folders = filePart.split('/');
        if (folders.length > 1) {
          var file = folders[1] || '';
          if (file.length) {
            return file;
          }
        }
      }
    }
  }
}});
Ext.define('flextable.components.fileViewer.Text', {extend:'Ext.panel.Panel', alias:'widget.ftText', layout:'fit', editor:undefined, value:undefined, readOnly:false, initComponent:function() {
  this.editorId = Ext.id();
  var wrapper = Ext.create({xtype:'container', html:'\x3cdiv style\x3d"height: 100%;width: 100%"\x3e\x3cdiv style\x3d"height: 100%;width: 100%" id\x3d"' + this.editorId + '"\x3e\x3c/div\x3e\x3c/div\x3e'});
  this.items = [wrapper];
  this.listeners = {afterrender:this.initEditor.bind(this), beforedestroy:this.destroyEditor.bind(this), resize:this.onResize.bind(this)};
  this.callParent(arguments);
}, initEditor:function() {
  var $jscomp$this = this;
  if (!window.ace) {
    lazyLoad.Ace().then(function() {
      $jscomp$this.initEditor();
    });
    return;
  }
  this.editor = ace.edit(this.editorId);
  this.editor.setTheme('ace/theme/chrome');
  this.editor.getSession().setMode('ace/mode/xml');
  this.editor.setOptions({enableBasicAutocompletion:true, enableLiveAutocompletion:true, showLineNumbers:true, showPrintMargin:false});
  if (this.readOnly) {
    this.editor.setReadOnly(true);
  }
  if (this.value) {
    this.setValue(this.value);
  }
}, onResize:function() {
  if (this.editor) {
    this.editor.resize();
  }
}, getValue:function() {
  if (this.editor) {
    return this.editor.getValue();
  }
}, setValue:function(value) {
  if (this.editor) {
    this.editor.setValue(value, -1);
  }
}, destroyEditor:function() {
  if (this.editor) {
    this.editor.destroy.bind(this.editor);
  }
}});
Ext.define('flextable.components.fileViewer.Tree', {extend:'Ext.tree.Panel', alias:'widget.ftTree', viewConfig:{enableTextSelection:true}, rootVisible:false, scrollable:true, fileSource:undefined, initComponent:function() {
  var $jscomp$this = this;
  var path = Ext.create({xtype:'button', iconCls:flextable.Support.getBpcIconCls('fa-code-branch')});
  var xmlData = this.parseXML(this.fileSource.replace(/<([a-zA-Z0-9]+)(?:xml)ns=".*"(.*)>/g, '\x3c$1$2\x3e').replace(/^\s/, ''));
  var childNode = CSS.escape(xmlData.childNodes[0].nodeName);
  var treeData = Ext.DomQuery.selectNode(childNode, xmlData);
  this.store = Ext.create('Ext.data.TreeStore', {root:{expanded:true, children:this.nodeToJsonTree(treeData)}});
  this.bbar = [path];
  this.listeners = {select:function(treeModel, node) {
    Ext.log({dump:node, msg:'select'});
    Ext.log({dump:node.getPath(), msg:'path'});
    var pathString = node.getPath();
    var recordIds = pathString.split('/');
    var namedPath = recordIds.map(function(name) {
      if (name === 'root') {
        return name;
      } else {
        var r = $jscomp$this.store.getById(name);
        if (r) {
          return r.get('text');
        }
        return name;
      }
    });
    path.setText(namedPath.join('/'));
  }, rowdblclick:function(tv, rec) {
    var textValue = rec.get('rawValue') || '';
    if (textValue.length > 0 && flextable.Support.copyToClipBoard(textValue, tv)) {
      BpcCommon.Api.showNotification(textValue + ' ' + flextable.Support.getTranslation('COPIED_SUCCESS'));
    }
  }};
  this.callParent(arguments);
  this.expandAll();
}, columns:[{xtype:'treecolumn', text:'Baum', dataIndex:'text', flex:4}, {text:'Item', dataIndex:'text', hidden:true, flex:1, renderer:function(val, meta, rec) {
  var textValue = rec.get('text') || '';
  return textValue.trim().indexOf(':') !== -1 ? textValue.split(':')[0] : textValue;
}}, {text:'Value', dataIndex:'text', hidden:true, flex:2, renderer:function(val, meta, rec) {
  var textValue = rec.get('text') || '';
  return textValue.trim().indexOf(':') !== -1 ? textValue.split(':')[1] : '';
}}], parseXML:function(dataInString) {
  if (window.DOMParser) {
    return (new window.DOMParser).parseFromString(dataInString, 'text/xml');
  } else {
    if (typeof window.ActiveXObject !== 'undefined' && new window.ActiveXObject('Microsoft.XMLDOM')) {
      var xmlDoc = new window.ActiveXObject('Microsoft.XMLDOM');
      xmlDoc.async = 'false';
      xmlDoc.loadXML(dataInString);
      return xmlDoc;
    }
  }
  return null;
}, nodeToJsonTree:function(node) {
  var jsonTree = {text:node.nodeName, draggable:false};
  var textValue = '';
  Ext.each(node.childNodes, function(item) {
    if (item.nodeType === 3 && item.textContent.trim() !== '') {
      textValue = textValue + item.textContent.trim() + ' ';
      textValue = textValue.replace(/</g, '\x26lt;');
      textValue = textValue.replace(/>/g, '\x26gt;');
    }
  }, this);
  var attributes = '';
  if (node.attributes) {
    for (var i = 0; i < node.attributes.length; i++) {
      attributes = attributes + node.attributes.item(i).name + '\x3d' + node.attributes.item(i).value + ' ';
    }
  }
  if (attributes.length > 0) {
    jsonTree.text = jsonTree.text + ' (' + attributes + ')';
  }
  if (textValue.length > 0) {
    jsonTree.text = jsonTree.text + ' : \x3cb\x3e' + textValue + '\x3c/b\x3e';
    jsonTree.rawValue = textValue || '';
  }
  if (!node.childElementCount || node.childElementCount < 1) {
    jsonTree.leaf = true;
    jsonTree.iconCls = '';
    jsonTree.icon = Ext.BLANK_IMAGE_URL;
  } else {
    jsonTree.leaf = false;
    jsonTree.icon = Ext.BLANK_IMAGE_URL;
    jsonTree.children = [];
    Ext.each(node.childNodes, function(node) {
      if (node.nodeType !== 3) {
        jsonTree.children.push(this.nodeToJsonTree(node));
      }
    }, this);
  }
  return jsonTree;
}});
Ext.define('flextable.moduleConfigurationComponents.Main', {extend:'BpcCommon.component.panel.moduleConfigurationComponents.Wrapper', alias:'widget.flextableConfigMain', initComponent:function() {
  this.callParent(arguments);
  this.setIconCls(BpcCommon.util.Icons.getBpcIconCls('fa-database'));
  this.setTitle(flextable.Support.getTranslation('FLEXTABLE_ADMIN'));
  this.saveButton.setVisible(false);
  this.resetButton.setVisible(false);
}, onSelect:function(grid, record) {
  this.settingsWrapper.removeAll();
  var moduleId = record.get('moduleId');
  this.settingsWrapper.add({xtype:'flextableTable', moduleId:moduleId, header:false});
}, getRendererConfig:function(moduleId) {
  var $jscomp$destructuring$var5 = BpcCommon.Api.getSetting(moduleId, flextable.Support.keys.cfg) || {};
  var renderer = $jscomp$destructuring$var5.renderer;
  return renderer || {};
}});
Ext.define('flextable.manager.Renderer', {extend:'Ext.panel.Panel', alias:'widget.flextableRenderer', title:'Renderer', viewConfig:{enableTextSelection:true}, layout:{type:'vbox', align:'stretch'}, initComponent:function() {
  var $jscomp$this = this;
  var conf = BpcCommon.Api.getSetting(this.moduleId, flextable.Support.keys.cfg) || {};
  var $jscomp$destructuring$var6 = conf;
  var renderer = $jscomp$destructuring$var6.renderer;
  var main = $jscomp$destructuring$var6.main;
  var details = $jscomp$destructuring$var6.details;
  renderer = renderer || {};
  main = main || {};
  details = details || {};
  var rendererNames = Object.keys(renderer || {});
  this.rendererStoreData = rendererNames.map(function(name) {
    var map = renderer[name].valueMap || {};
    return {id:name, data:Object.keys(map).map(function(value) {
      var item = map[value] || {};
      item.value = value;
      return item;
    })};
  });
  this.rendererGrid = Ext.create({title:'\x3e ' + (rendererNames.length ? rendererNames[0] : flextable.Support.getTranslation('NO_RENDERER_DEFINED')), xtype:'grid', flex:1, viewConfig:{emptyText:flextable.Support.getTranslation('NO_DATA')}, store:Ext.create('Ext.data.Store', {data:rendererNames.length ? this.rendererStoreData.filter(function(item) {
    return item.id === rendererNames[0];
  })[0].data : []}), columns:['value', 'label', 'iconCls', 'color'].map(function(id) {
    var col = {dataIndex:id, text:id.toUpperCase(), flex:id === 'label' || id === 'value' ? 2 : 1};
    if (id === 'iconCls') {
      col.renderer = function(v, m, r) {
        return flextable.Support.getSpanForIconCls(v, r.get('color'));
      };
    }
    return col;
  }).concat([{xtype:'actioncolumn', width:60, items:[{iconCls:flextable.Support.getBpcIconCls('fa-copy'), handler:function(tv, rowIndex, colIndex) {
    var data = tv.store.getAt(rowIndex).getData();
    tv.store.add({value:data.value || '', iconCls:data.iconCls || '', label:data.label || '', color:data.color || '#eee'});
  }}, {iconCls:flextable.Support.getBpcIconCls('fa-times'), handler:function(tv, rowIndex, colIndex) {
    tv.store.removeAt(rowIndex);
  }}]}]), tbar:[{xtype:'checkbox', margin:'0 0 0 5', boxLabel:flextable.Support.getTranslation('ICON_ONLY')}, {xtype:'checkbox', margin:'0 0 0 5', boxLabel:flextable.Support.getTranslation('COMPARE_LOWER')}, {xtype:'tbfill'}, {text:flextable.Support.getTranslation('ADD_EMPTY')}, {text:flextable.Support.getTranslation('ADD_MATCH_ALL_FALLBACK')}], bbar:[{text:'Usages: '}, {xtype:'tbfill'}, {iconCls:flextable.Support.getBpcIconCls('fa-save')}]});
  this.items = [this.rendererGrid];
  var getCount = function(cols, dataIndex) {
    cols = cols || [];
    return cols.filter(function(col) {
      return col.dataIndex === dataIndex;
    }).length;
  };
  var getTitle = function(dataIndex) {
    return '\x3e ' + dataIndex;
  };
  this.tbar = rendererNames.map(function(name) {
    return {text:name, rendererBtn:true, scope:$jscomp$this, handler:function(b) {
      this.rendererGrid.store.removeAll();
      this.rendererGrid.setTitle(getTitle(b.text));
      this.rendererGrid.store.add(this.rendererStoreData.filter(function(item) {
        return item.id === b.text;
      })[0].data || []);
    }};
  }).concat([{xtype:'tbfill'}, {text:flextable.Support.getTranslation('REMOVE_ALL'), handler:function(btn) {
    this.rendererGrid.setTitle(flextable.Support.getTranslation('NO_RENDERER'));
    this.rendererGrid.store.removeAll();
    this.rendererStoreData = [];
    this.query('button[rendererBtn]').map(function(b) {
      return b.destroy();
    });
  }.bind(this)}]);
  this.callParent(arguments);
}});
Ext.define('flextable.manager.Table', {extend:'Ext.panel.Panel', alias:'widget.flextableTable', layout:{type:'vbox', align:'stretch'}, initComponent:function() {
  var $jscomp$this = this;
  this.title = flextable.Support.getTranslation('CONNECTION_INFO');
  this.iconCls = flextable.Support.getBpcIconCls('fa-ethernet');
  this.connectionInfoPanelToolbar = Ext.create({xtype:'toolbar'});
  this.schemaCatalogLoadButton = Ext.create({xtype:'button', iconCls:flextable.Support.getBpcIconCls('fa-sync'), text:'Schemas \x26 Catalogs', handler:function() {
    $jscomp$this.loadSchemasAndCatalogs();
  }, disabled:true});
  this.tablesViewsLoadButton = Ext.create({xtype:'button', iconCls:flextable.Support.getBpcIconCls('fa-sync'), text:'Tables \x26 Views', handler:function() {
    $jscomp$this.loadTablesAndViews();
  }});
  this.connectionHandlerToolbar = Ext.create({xtype:'toolbar', items:[this.schemaCatalogLoadButton, this.tablesViewsLoadButton]});
  this.connectionInfoPanel = Ext.create({xtype:'fieldset', title:flextable.Support.getTranslation('CONNECTION_DETAILS'), layout:'fit', items:[this.connectionInfoPanelToolbar]});
  this.primaryStore = Ext.create('Ext.data.Store', {data:[]});
  this.columnStore = Ext.create('Ext.data.Store', {data:[]});
  this.schemaFieldSet = Ext.create(this.getFieldsetColumn(flextable.Support.getTranslation('TABLES_SCHEMAS'), 'schemaName', [{dataIndex:'TABLE_SCHEM', flex:1}, {dataIndex:'TABLE_CATALOG', flex:1, hidden:true}], 'TABLE_SCHEM'));
  this.catalogsFieldSet = Ext.create(this.getFieldsetColumn(flextable.Support.getTranslation('TABLES_CATALOGS'), 'catalogName', [{dataIndex:'TABLE_CAT', flex:1}], 'TABLE_CAT'));
  var cfg = this.getFieldsetColumn(flextable.Support.getTranslation('TABLES_VIEWS'), 'tableViewName', [{dataIndex:'TABLE_NAME', flex:1}, {dataIndex:'type'}], 'TABLE_NAME', [{iconCls:flextable.Support.getBpcIconCls('fa-plus'), handler:function() {
    Ext.create('Ext.window.Window', {title:'Hello', height:document.body.clientHeight * 0.2, width:document.body.clientWidth * 0.5, layout:'fit', items:[{xtype:'textfield'}], bbar:[{xtype:'tbfill'}, {iconCls:flextable.Support.getBpcIconCls('fa-save')}]}).show();
  }}]);
  cfg.selectField.on('change', function(f, newVal) {
    $jscomp$this.primaryStore.removeAll();
    $jscomp$this.columnStore.removeAll();
    if (newVal && newVal.length) {
      flextable.Api.getTableMeta($jscomp$this.moduleId, newVal).then(function(obj) {
        $jscomp$this.primaryStore.add(obj.tableColumnPrimaryKeys || []);
        $jscomp$this.columnStore.add(obj.tableColumnDetails || []);
      });
    }
  });
  this.tableViewsFieldSet = Ext.create(cfg);
  this.items = [this.connectionInfoPanel, this.connectionHandlerToolbar, {xtype:'panel', flex:2, layout:{type:'hbox', align:'stretch'}, items:[this.schemaFieldSet, this.catalogsFieldSet, this.tableViewsFieldSet, {xtype:'fieldset', flex:2, title:flextable.Support.getTranslation('TABLE_DETAILS'), layout:{type:'vbox', align:'stretch'}, items:[{xtype:'grid', viewConfig:{emptyText:flextable.Support.getTranslation('NO_DATA')}, minHeight:100, title:flextable.Support.getTranslation('PRIMARY_KEYS'), iconCls:flextable.Support.getBpcIconCls('fa-star-of-life'), 
  store:this.primaryStore, style:'border:0px!important;', columns:[{dataIndex:'COLUMN_NAME', flex:1}, {dataIndex:'PK_NAME', flex:1}]}, {xtype:'grid', flex:2, title:flextable.Support.getTranslation('COLUMN_INFO'), iconCls:flextable.Support.getBpcIconCls('fa-columns'), store:this.columnStore, style:'border:0px!important;', viewConfig:{emptyText:flextable.Support.getTranslation('NO_DATA')}, columns:[{dataIndex:'COLUMN_NAME', flex:1}, {dataIndex:'DATA_TYPE'}, {dataIndex:'IS_AUTOINCREMENT', hidden:true}, 
  {dataIndex:'IS_NULLABLE', hidden:true}, {dataIndex:'COLUMN_SIZE', hidden:true}]}]}]}];
  this.callParent(arguments);
  this.loadDriverData();
}, getFieldsetColumn:function(title, itemId, columns, selectRecordField, buttons) {
  columns = columns === undefined ? [] : columns;
  buttons = buttons === undefined ? [] : buttons;
  var selectField = Ext.create({xtype:'textfield', emptyText:title, itemId:itemId + 'Field', flex:1});
  var totalBtn = Ext.create({xtype:'button', iconCls:flextable.Support.getBpcIconCls('fa-database'), text:'0'});
  var grid = Ext.create({xtype:'grid', style:'border:0px!important;', viewConfig:{emptyText:flextable.Support.getTranslation('NO_DATA')}, tbar:[selectField], bbar:buttons.concat([{xtype:'tbfill'}, totalBtn]), store:Ext.create('Ext.data.Store', {data:[], listeners:{datachanged:function(s) {
    totalBtn.setText('' + s.getCount());
  }}}), columns:columns, listeners:{select:function(selModel, r) {
    selectField.setValue(r.get(selectRecordField));
  }}});
  return {xtype:'fieldset', title:title, flex:1, layout:'fit', selectField:selectField, grid:grid, itemId:itemId, items:[grid]};
}, loadTablesAndViews:function() {
  var $jscomp$this = this;
  this.tableViewsFieldSet.grid.store.removeAll();
  flextable.Api.getTablesViews(this.moduleId, {mode:'tablesViews', schemaName:this.schemaFieldSet.selectField.getValue()}).then(function(data) {
    var storeData = (data.tables || []).concat(data.views || []);
    $jscomp$this.tableViewsFieldSet.grid.store.add(storeData);
  });
}, loadSchemasAndCatalogs:function() {
  var $jscomp$this = this;
  flextable.Api.getSchemas(this.moduleId).then(function(data) {
    $jscomp$this.schemaFieldSet.grid.store.add(data.schemas || []);
  }).then(function() {
    return flextable.Api.getCatalogs($jscomp$this.moduleId);
  }).then(function(data) {
    $jscomp$this.catalogsFieldSet.grid.store.add(data.catalogs || []);
  });
}, loadDriverData:function() {
  var $jscomp$this = this;
  this.setLoading(flextable.Support.getTranslation('FETCHING_DATA'));
  flextable.Api.getDriverInfo(this.moduleId).then(function(connectionObject) {
    var driver = (connectionObject || {}).driver || {};
    Object.keys(driver).map(function(propName) {
      $jscomp$this.connectionInfoPanelToolbar.add({xtype:'textfield', fieldLabel:flextable.Support.getTranslation('DB_' + propName), value:driver[propName] || '-1', readOnly:true, flex:1});
    });
  }).then(function() {
    $jscomp$this.schemaCatalogLoadButton.setDisabled(false);
  })['catch'](function(e) {
  })['finally'](function() {
    $jscomp$this.setLoading(false);
  });
}});
Ext.define('flextable.plugin.BpcPluginMixin', {getValueFromPluginConfiguration:function(key, fromContext) {
  if (this.pluginConfiguration && Ext.isObject(this.pluginConfiguration)) {
    if (!fromContext) {
      if (this.pluginConfiguration.configuration && Ext.isObject(this.pluginConfiguration.configuration)) {
        var pluginConfig = this.pluginConfiguration.configuration;
        if (key in pluginConfig && pluginConfig[key]) {
          return pluginConfig[key];
        }
      }
    } else {
      if (fromContext) {
        if (this.pluginConfiguration.context && Ext.isObject(this.pluginConfiguration.context)) {
          var ctx = this.pluginConfiguration.context;
          if (key in ctx && ctx[key]) {
            return ctx[key];
          }
        }
      }
    }
  }
}, isCmpUsedAsPlugin:function() {
  var me = this;
  return 'pluginConfiguration' in me && me.pluginConfiguration && Ext.isObject(me.pluginConfiguration);
}});
Ext.define('flextable.plugin.detailWindow.Main', {extend:'Ext.panel.Panel', alias:'widget.flextablePlugin', mixins:['flextable.plugin.BpcPluginMixin'], layout:'fit', padding:'5 5 5 5', idValue:undefined, legacy:false, flexTableParams:undefined, previewFileWrapperItemId:undefined, baseTitle:'', forceActiveTab:false, initComponent:function() {
  var $jscomp$this = this;
  this.iconCls = flextable.Support.getBpcIconCls(this.getValueFromPluginConfiguration('iconCls') || 'fa-database');
  this.moduleId = this.getValueFromPluginConfiguration('moduleId') || undefined;
  var pTargetModuleId = this.getValueFromPluginConfiguration('instanceId', true);
  var rec = this.getValueFromPluginConfiguration('record', true);
  this.baseTitle = this.getValueFromPluginConfiguration('title');
  this.idValue = rec.get(BpcCommon.Api.getSetting(pTargetModuleId, 'column_id'));
  this.pluginSortColumn = this.getValueFromPluginConfiguration('sortColumn') || BpcCommon.Api.getSetting(this.moduleId, 'sortColumn');
  this.pluginSortDirection = this.getValueFromPluginConfiguration('sortDirection') || BpcCommon.Api.getSetting(this.moduleId, 'sortDirection');
  this.previewFileWrapperItemId = this.getValueFromPluginConfiguration('previewFileWrapperItemId');
  var forceActiveTab = this.getValueFromPluginConfiguration('forceActiveTab');
  if (forceActiveTab === true) {
    this.forceActiveTab = true;
  }
  var metaHidden = this.getValueFromPluginConfiguration('fileViewer_metaHidden');
  this.flextable = Ext.create({xtype:'flextableMain', isBpcModule:false, moduleId:this.moduleId, fileViewerMetaHidden:metaHidden === true, showToolbars:false, idKey:Ext.isDefined(this.idValue) ? false : undefined, onTableCreated:this.onTableCreated.bind(this)});
  this.listeners = {added:function(c, owner) {
    var types = owner.getXTypes();
    types = types.split('/').map(function(t) {
      return t.toLowerCase();
    });
    if ($jscomp$this.forceActiveTab && types.indexOf('tabpanel') !== -1) {
      Ext.defer(function() {
        owner.setActiveTab(c);
      }, 1000);
      return;
    } else {
      var layout = owner.getLayout();
      if (layout && layout.config) {
        var $jscomp$destructuring$var7 = layout;
        var config = $jscomp$destructuring$var7.config;
        config = config || {};
        var $jscomp$destructuring$var8 = config;
        var type = $jscomp$destructuring$var8.type;
        type = type || '';
        if (type === 'hbox' || type === 'vbox') {
          c.setFlex(1);
          return;
        }
      }
      if (c.header) {
        c.header.hide();
      } else {
        c.header = false;
      }
    }
  }};
  this.items = [this.flextable];
  this.callParent(arguments);
  this.updateTitle();
}, onTableCreated:function() {
  var $jscomp$this = this;
  if (Ext.isDefined(this.idValue)) {
    this.flextable.grid.changeExtraParams({idValue:this.idValue});
    this.flextable.grid.flexContext = {processId:this.idValue};
  }
  this.flextable.grid.store.on('load', function(s, records, success) {
    if ($jscomp$this.pluginSortColumn && $jscomp$this.pluginSortColumn.length) {
      s.sort({property:$jscomp$this.pluginSortColumn, direction:$jscomp$this.pluginSortDirection});
    }
    $jscomp$this.updateTitle(success ? records.length : 0);
    if (success) {
      if ($jscomp$this.previewFileWrapperItemId) {
        if ($jscomp$this.ownerCt) {
          var win = $jscomp$this.ownerCt.up('window');
          if (win) {
            var wrapper = win.down('#' + $jscomp$this.previewFileWrapperItemId);
            if (wrapper) {
              wrapper.removeAll();
              var storeData = $jscomp$this.getAttachments(records);
              storeData = storeData.map(function(o) {
                var newObj = Ext.apply({}, o.r.getData());
                if (newObj.id) {
                  delete newObj.id;
                }
                return newObj;
              });
              wrapper.add({xtype:'grid', store:Ext.create('Ext.data.Store', {data:storeData}), columns:$jscomp$this.flextable.grid.getActionColumnConfig($jscomp$this.moduleId).concat([{dataIndex:'REFERENZ', text:'Referenz', flex:1}, {dataIndex:'MIMETYPE', text:'Mime', flex:1}])});
            }
          }
        }
      }
    }
  });
  this.flextable.load();
}, getAttachments:function(records) {
  var $jscomp$this = this;
  records = records === undefined ? [] : records;
  records = records.map(function(r) {
    return {r:r, attachment:$jscomp$this.flextable.grid.getAttachment(r)};
  }).filter(function(o) {
    return Ext.isDefined(o.attachment) && o.attachment !== null;
  });
  return records;
}, updateTitle:function(num) {
  num = num || 0;
  var prefix = this.baseTitle || 'FLEXTABLE';
  this.setTitle(prefix + ' ( ' + num + ' ) ');
}});
Ext.define('flextable.plugin.detailWindow.Wrapper', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'Flextable Plugin', COMPONENT_XTYPE:'flextablePlugin', PLUGIN_ID:'flextable-detailwindow-plugin'}});
Ext.define('flextable.plugin.hooks.Base', {extend:'BpcCommon.plugin.HookContainer', context:undefined, autoInjectPlugins:false, pluginComponentDefinitions:[], hidden:true, assetConfiguration:undefined, initComponent:function() {
  Ext.isDefined(this.assetConfiguration) ? this.context.assetConfig = this.assetConfiguration : undefined;
  var pluginComponents = [];
  try {
    pluginComponents = BpcCommon.Api.getPluginComponents(this, this.context) || [];
  } catch (e$5) {
    pluginComponents = [];
  }
  if (Ext.isArray(pluginComponents)) {
    this.enrichPlugins(pluginComponents);
  }
  this.callParent(arguments);
}, getPluginDefinitions:function() {
  return this.pluginComponentDefinitions || [];
}, enrichPlugins:function(pluginComponents) {
  pluginComponents = pluginComponents === undefined ? [] : pluginComponents;
  this.pluginComponentDefinitions = pluginComponents.map(function(obj) {
    return obj;
  });
}});
Ext.define('flextable.plugin.hooks.GridActions', {extend:'flextable.plugin.hooks.Base', alias:'widget.flextableGridActionHook', inheritableStatics:{NAME:'Flextable Action Hook', HOOK_ID:'flextable_grid_actions', HOOK_LEVEL:'instance'}});
Ext.define('flextable.view.Main', {extend:'Ext.panel.Panel', alias:'widget.flextableMain', layout:'fit', moduleId:undefined, idKey:undefined, showToolbars:true, initColumns:undefined, isBpcModule:true, header:false, fileViewerMetaHidden:undefined, initComponent:function() {
  var $jscomp$this = this;
  var idKey = this.idKey === false ? undefined : this.idKey || BpcCommon.Api.getSetting(this.moduleId, flextable.Support.keys.id);
  if (this.isBpcModule) {
    this.addBpcModuleFeatures();
  }
  this.callParent(arguments);
  flextable.Support.preloadPluginModules(this.moduleId).then(function(config) {
    if (config) {
    }
    $jscomp$this.createTable(idKey);
    $jscomp$this.load();
  });
}, createTable:function(idKey) {
  this.grid = Ext.create({xtype:'flextableGrid', moduleId:this.moduleId, moduleInstance:this, idKey:idKey, mode:this.idKey === false ? 'details' : undefined});
  this.add(this.grid);
  this.onTableCreated();
}, onTableCreated:function() {
}, addBpcModuleFeatures:function() {
  this.bpcModuleHeader = Ext.createByAlias('widget.flextableModuleHeader', {moduleId:this.moduleId, moduleInstance:this});
  this.applicationToolbarRight = Ext.create({xtype:'toolbar', layout:{pack:'end'}, items:[{scope:this, handler:this.load, tooltip:flextable.Support.getTranslation('REFRESH'), iconCls:flextable.Support.getBpcIconCls('fa-sync')}]});
}, load:function() {
  this.grid.store.load();
}, getColumn:function(dataIndex) {
  return this.grid.getColumns().filter(function(col) {
    return col.dataIndex === dataIndex;
  }).map(function(col) {
    return {text:col.text || col.header || '', dataIndex:dataIndex, renderer:col.renderer || undefined};
  });
}});
Ext.define('flextable.view.ModuleHeader', {extend:'Ext.container.Container', alias:'widget.flextableModuleHeader', layout:{type:'hbox', align:'stretch'}, moduleId:undefined, initComponent:function() {
  this.items = [];
  this.callParent(arguments);
}});
